﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'Address' using it's primary key(s)
		/// Tabelle Address
        /// </summary>
        /// <returns>a new object of entity 'Address', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetAddress", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Address GetAddress(int addressId);

        /// <summary>
        /// get list of entities 'AddressList' using a Where clause
		/// Database Table Address
        /// </summary>
        /// <returns>Entity 'AddressList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetAddressList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        AddressList GetAddressList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'Address', accourding to entity content and state.
		/// Database Table Address
        /// </summary>
        /// <returns>Entity 'Address', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveAddress", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Address SaveAddress(Address item);

        /// <summary>
        /// Remove existing entity 'Address'
		/// Database Table Address
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveAddress", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveAddress(Address item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetAddress" />
		/// Database Table Address
        /// </summary>
        virtual public Address GetAddress(int addressId)
        {
		    Address result = null;
			this.Execute((manager) =>
			{
				result = manager.GetAddress(addressId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetAddressList" />
		/// Database Table Address
        /// </summary>
        virtual public AddressList GetAddressList(SqlWhereClause where)
        {
			AddressList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetAddressList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveAddress" />
		/// Database Table Address
        /// </summary>
        virtual public Address SaveAddress(Address item)
        {
			Address result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveAddress(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveAddress" />
		/// Database Table Address
        /// </summary>
        virtual public bool RemoveAddress(Address item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveAddress(item);
			});
			return result;
        }
    }
}