﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'AddressType' using it's primary key(s)
		/// Tabelle AddressType
        /// </summary>
        /// <returns>a new object of entity 'AddressType', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetAddressType", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        AddressType GetAddressType(int addressTypeId);

        /// <summary>
        /// get list of entities 'AddressTypeList' using a Where clause
		/// Database Table AddressType
        /// </summary>
        /// <returns>Entity 'AddressTypeList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetAddressTypeList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        AddressTypeList GetAddressTypeList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'AddressType', accourding to entity content and state.
		/// Database Table AddressType
        /// </summary>
        /// <returns>Entity 'AddressType', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveAddressType", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        AddressType SaveAddressType(AddressType item);

        /// <summary>
        /// Remove existing entity 'AddressType'
		/// Database Table AddressType
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveAddressType", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveAddressType(AddressType item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetAddressType" />
		/// Database Table AddressType
        /// </summary>
        virtual public AddressType GetAddressType(int addressTypeId)
        {
		    AddressType result = null;
			this.Execute((manager) =>
			{
				result = manager.GetAddressType(addressTypeId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetAddressTypeList" />
		/// Database Table AddressType
        /// </summary>
        virtual public AddressTypeList GetAddressTypeList(SqlWhereClause where)
        {
			AddressTypeList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetAddressTypeList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveAddressType" />
		/// Database Table AddressType
        /// </summary>
        virtual public AddressType SaveAddressType(AddressType item)
        {
			AddressType result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveAddressType(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveAddressType" />
		/// Database Table AddressType
        /// </summary>
        virtual public bool RemoveAddressType(AddressType item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveAddressType(item);
			});
			return result;
        }
    }
}