﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'AwbUildVersion' using it's primary key(s)
		/// Tabelle AWBuildVersion
        /// </summary>
        /// <returns>a new object of entity 'AwbUildVersion', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetAwbUildVersion", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        AwbUildVersion GetAwbUildVersion(byte systemInformationId);

        /// <summary>
        /// get list of entities 'AwbUildVersionList' using a Where clause
		/// Database Table AWBuildVersion
        /// </summary>
        /// <returns>Entity 'AwbUildVersionList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetAwbUildVersionList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        AwbUildVersionList GetAwbUildVersionList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'AwbUildVersion', accourding to entity content and state.
		/// Database Table AWBuildVersion
        /// </summary>
        /// <returns>Entity 'AwbUildVersion', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveAwbUildVersion", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        AwbUildVersion SaveAwbUildVersion(AwbUildVersion item);

        /// <summary>
        /// Remove existing entity 'AwbUildVersion'
		/// Database Table AWBuildVersion
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveAwbUildVersion", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveAwbUildVersion(AwbUildVersion item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetAwbUildVersion" />
		/// Database Table AWBuildVersion
        /// </summary>
        virtual public AwbUildVersion GetAwbUildVersion(byte systemInformationId)
        {
		    AwbUildVersion result = null;
			this.Execute((manager) =>
			{
				result = manager.GetAwbUildVersion(systemInformationId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetAwbUildVersionList" />
		/// Database Table AWBuildVersion
        /// </summary>
        virtual public AwbUildVersionList GetAwbUildVersionList(SqlWhereClause where)
        {
			AwbUildVersionList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetAwbUildVersionList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveAwbUildVersion" />
		/// Database Table AWBuildVersion
        /// </summary>
        virtual public AwbUildVersion SaveAwbUildVersion(AwbUildVersion item)
        {
			AwbUildVersion result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveAwbUildVersion(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveAwbUildVersion" />
		/// Database Table AWBuildVersion
        /// </summary>
        virtual public bool RemoveAwbUildVersion(AwbUildVersion item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveAwbUildVersion(item);
			});
			return result;
        }
    }
}