﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'BillOfMaterials' using it's primary key(s)
		/// Tabelle BillOfMaterials
        /// </summary>
        /// <returns>a new object of entity 'BillOfMaterials', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetBillOfMaterials", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        BillOfMaterials GetBillOfMaterials(int billOfMaterialsId);

        /// <summary>
        /// get list of entities 'BillOfMaterialsList' using a Where clause
		/// Database Table BillOfMaterials
        /// </summary>
        /// <returns>Entity 'BillOfMaterialsList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetBillOfMaterialsList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        BillOfMaterialsList GetBillOfMaterialsList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'BillOfMaterials', accourding to entity content and state.
		/// Database Table BillOfMaterials
        /// </summary>
        /// <returns>Entity 'BillOfMaterials', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveBillOfMaterials", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        BillOfMaterials SaveBillOfMaterials(BillOfMaterials item);

        /// <summary>
        /// Remove existing entity 'BillOfMaterials'
		/// Database Table BillOfMaterials
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveBillOfMaterials", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveBillOfMaterials(BillOfMaterials item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetBillOfMaterials" />
		/// Database Table BillOfMaterials
        /// </summary>
        virtual public BillOfMaterials GetBillOfMaterials(int billOfMaterialsId)
        {
		    BillOfMaterials result = null;
			this.Execute((manager) =>
			{
				result = manager.GetBillOfMaterials(billOfMaterialsId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetBillOfMaterialsList" />
		/// Database Table BillOfMaterials
        /// </summary>
        virtual public BillOfMaterialsList GetBillOfMaterialsList(SqlWhereClause where)
        {
			BillOfMaterialsList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetBillOfMaterialsList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveBillOfMaterials" />
		/// Database Table BillOfMaterials
        /// </summary>
        virtual public BillOfMaterials SaveBillOfMaterials(BillOfMaterials item)
        {
			BillOfMaterials result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveBillOfMaterials(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveBillOfMaterials" />
		/// Database Table BillOfMaterials
        /// </summary>
        virtual public bool RemoveBillOfMaterials(BillOfMaterials item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveBillOfMaterials(item);
			});
			return result;
        }
    }
}