﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'BusinessEntityAddress' using it's primary key(s)
		/// Tabelle BusinessEntityAddress
        /// </summary>
        /// <returns>a new object of entity 'BusinessEntityAddress', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetBusinessEntityAddress", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        BusinessEntityAddress GetBusinessEntityAddress(int businessEntityId, int addressId, int addressTypeId);

        /// <summary>
        /// get list of entities 'BusinessEntityAddressList' using a Where clause
		/// Database Table BusinessEntityAddress
        /// </summary>
        /// <returns>Entity 'BusinessEntityAddressList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetBusinessEntityAddressList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        BusinessEntityAddressList GetBusinessEntityAddressList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'BusinessEntityAddress', accourding to entity content and state.
		/// Database Table BusinessEntityAddress
        /// </summary>
        /// <returns>Entity 'BusinessEntityAddress', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveBusinessEntityAddress", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        BusinessEntityAddress SaveBusinessEntityAddress(BusinessEntityAddress item);

        /// <summary>
        /// Remove existing entity 'BusinessEntityAddress'
		/// Database Table BusinessEntityAddress
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveBusinessEntityAddress", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveBusinessEntityAddress(BusinessEntityAddress item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetBusinessEntityAddress" />
		/// Database Table BusinessEntityAddress
        /// </summary>
        virtual public BusinessEntityAddress GetBusinessEntityAddress(int businessEntityId, int addressId, int addressTypeId)
        {
		    BusinessEntityAddress result = null;
			this.Execute((manager) =>
			{
				result = manager.GetBusinessEntityAddress(businessEntityId, addressId, addressTypeId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetBusinessEntityAddressList" />
		/// Database Table BusinessEntityAddress
        /// </summary>
        virtual public BusinessEntityAddressList GetBusinessEntityAddressList(SqlWhereClause where)
        {
			BusinessEntityAddressList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetBusinessEntityAddressList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveBusinessEntityAddress" />
		/// Database Table BusinessEntityAddress
        /// </summary>
        virtual public BusinessEntityAddress SaveBusinessEntityAddress(BusinessEntityAddress item)
        {
			BusinessEntityAddress result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveBusinessEntityAddress(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveBusinessEntityAddress" />
		/// Database Table BusinessEntityAddress
        /// </summary>
        virtual public bool RemoveBusinessEntityAddress(BusinessEntityAddress item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveBusinessEntityAddress(item);
			});
			return result;
        }
    }
}