﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'BusinessEntityContact' using it's primary key(s)
		/// Tabelle BusinessEntityContact
        /// </summary>
        /// <returns>a new object of entity 'BusinessEntityContact', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetBusinessEntityContact", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        BusinessEntityContact GetBusinessEntityContact(int businessEntityId, int personId, int contactTypeId);

        /// <summary>
        /// get list of entities 'BusinessEntityContactList' using a Where clause
		/// Database Table BusinessEntityContact
        /// </summary>
        /// <returns>Entity 'BusinessEntityContactList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetBusinessEntityContactList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        BusinessEntityContactList GetBusinessEntityContactList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'BusinessEntityContact', accourding to entity content and state.
		/// Database Table BusinessEntityContact
        /// </summary>
        /// <returns>Entity 'BusinessEntityContact', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveBusinessEntityContact", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        BusinessEntityContact SaveBusinessEntityContact(BusinessEntityContact item);

        /// <summary>
        /// Remove existing entity 'BusinessEntityContact'
		/// Database Table BusinessEntityContact
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveBusinessEntityContact", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveBusinessEntityContact(BusinessEntityContact item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetBusinessEntityContact" />
		/// Database Table BusinessEntityContact
        /// </summary>
        virtual public BusinessEntityContact GetBusinessEntityContact(int businessEntityId, int personId, int contactTypeId)
        {
		    BusinessEntityContact result = null;
			this.Execute((manager) =>
			{
				result = manager.GetBusinessEntityContact(businessEntityId, personId, contactTypeId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetBusinessEntityContactList" />
		/// Database Table BusinessEntityContact
        /// </summary>
        virtual public BusinessEntityContactList GetBusinessEntityContactList(SqlWhereClause where)
        {
			BusinessEntityContactList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetBusinessEntityContactList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveBusinessEntityContact" />
		/// Database Table BusinessEntityContact
        /// </summary>
        virtual public BusinessEntityContact SaveBusinessEntityContact(BusinessEntityContact item)
        {
			BusinessEntityContact result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveBusinessEntityContact(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveBusinessEntityContact" />
		/// Database Table BusinessEntityContact
        /// </summary>
        virtual public bool RemoveBusinessEntityContact(BusinessEntityContact item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveBusinessEntityContact(item);
			});
			return result;
        }
    }
}