﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ContactType' using it's primary key(s)
		/// Tabelle ContactType
        /// </summary>
        /// <returns>a new object of entity 'ContactType', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetContactType", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ContactType GetContactType(int contactTypeId);

        /// <summary>
        /// get list of entities 'ContactTypeList' using a Where clause
		/// Database Table ContactType
        /// </summary>
        /// <returns>Entity 'ContactTypeList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetContactTypeList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ContactTypeList GetContactTypeList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ContactType', accourding to entity content and state.
		/// Database Table ContactType
        /// </summary>
        /// <returns>Entity 'ContactType', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveContactType", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ContactType SaveContactType(ContactType item);

        /// <summary>
        /// Remove existing entity 'ContactType'
		/// Database Table ContactType
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveContactType", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveContactType(ContactType item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetContactType" />
		/// Database Table ContactType
        /// </summary>
        virtual public ContactType GetContactType(int contactTypeId)
        {
		    ContactType result = null;
			this.Execute((manager) =>
			{
				result = manager.GetContactType(contactTypeId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetContactTypeList" />
		/// Database Table ContactType
        /// </summary>
        virtual public ContactTypeList GetContactTypeList(SqlWhereClause where)
        {
			ContactTypeList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetContactTypeList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveContactType" />
		/// Database Table ContactType
        /// </summary>
        virtual public ContactType SaveContactType(ContactType item)
        {
			ContactType result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveContactType(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveContactType" />
		/// Database Table ContactType
        /// </summary>
        virtual public bool RemoveContactType(ContactType item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveContactType(item);
			});
			return result;
        }
    }
}