﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'CountryRegion' using it's primary key(s)
		/// Tabelle CountryRegion
        /// </summary>
        /// <returns>a new object of entity 'CountryRegion', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCountryRegion", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CountryRegion GetCountryRegion(string countryRegionCode);

        /// <summary>
        /// get list of entities 'CountryRegionList' using a Where clause
		/// Database Table CountryRegion
        /// </summary>
        /// <returns>Entity 'CountryRegionList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCountryRegionList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CountryRegionList GetCountryRegionList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'CountryRegion', accourding to entity content and state.
		/// Database Table CountryRegion
        /// </summary>
        /// <returns>Entity 'CountryRegion', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveCountryRegion", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CountryRegion SaveCountryRegion(CountryRegion item);

        /// <summary>
        /// Remove existing entity 'CountryRegion'
		/// Database Table CountryRegion
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveCountryRegion", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveCountryRegion(CountryRegion item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetCountryRegion" />
		/// Database Table CountryRegion
        /// </summary>
        virtual public CountryRegion GetCountryRegion(string countryRegionCode)
        {
		    CountryRegion result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCountryRegion(countryRegionCode);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetCountryRegionList" />
		/// Database Table CountryRegion
        /// </summary>
        virtual public CountryRegionList GetCountryRegionList(SqlWhereClause where)
        {
			CountryRegionList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCountryRegionList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveCountryRegion" />
		/// Database Table CountryRegion
        /// </summary>
        virtual public CountryRegion SaveCountryRegion(CountryRegion item)
        {
			CountryRegion result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveCountryRegion(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveCountryRegion" />
		/// Database Table CountryRegion
        /// </summary>
        virtual public bool RemoveCountryRegion(CountryRegion item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveCountryRegion(item);
			});
			return result;
        }
    }
}