﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'CountryRegionCurrency' using it's primary key(s)
		/// Tabelle CountryRegionCurrency
        /// </summary>
        /// <returns>a new object of entity 'CountryRegionCurrency', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCountryRegionCurrency", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CountryRegionCurrency GetCountryRegionCurrency(string countryRegionCode, string currencyCode);

        /// <summary>
        /// get list of entities 'CountryRegionCurrencyList' using a Where clause
		/// Database Table CountryRegionCurrency
        /// </summary>
        /// <returns>Entity 'CountryRegionCurrencyList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCountryRegionCurrencyList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CountryRegionCurrencyList GetCountryRegionCurrencyList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'CountryRegionCurrency', accourding to entity content and state.
		/// Database Table CountryRegionCurrency
        /// </summary>
        /// <returns>Entity 'CountryRegionCurrency', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveCountryRegionCurrency", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CountryRegionCurrency SaveCountryRegionCurrency(CountryRegionCurrency item);

        /// <summary>
        /// Remove existing entity 'CountryRegionCurrency'
		/// Database Table CountryRegionCurrency
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveCountryRegionCurrency", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveCountryRegionCurrency(CountryRegionCurrency item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetCountryRegionCurrency" />
		/// Database Table CountryRegionCurrency
        /// </summary>
        virtual public CountryRegionCurrency GetCountryRegionCurrency(string countryRegionCode, string currencyCode)
        {
		    CountryRegionCurrency result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCountryRegionCurrency(countryRegionCode, currencyCode);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetCountryRegionCurrencyList" />
		/// Database Table CountryRegionCurrency
        /// </summary>
        virtual public CountryRegionCurrencyList GetCountryRegionCurrencyList(SqlWhereClause where)
        {
			CountryRegionCurrencyList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCountryRegionCurrencyList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveCountryRegionCurrency" />
		/// Database Table CountryRegionCurrency
        /// </summary>
        virtual public CountryRegionCurrency SaveCountryRegionCurrency(CountryRegionCurrency item)
        {
			CountryRegionCurrency result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveCountryRegionCurrency(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveCountryRegionCurrency" />
		/// Database Table CountryRegionCurrency
        /// </summary>
        virtual public bool RemoveCountryRegionCurrency(CountryRegionCurrency item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveCountryRegionCurrency(item);
			});
			return result;
        }
    }
}