﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'CreditCard' using it's primary key(s)
		/// Tabelle CreditCard
        /// </summary>
        /// <returns>a new object of entity 'CreditCard', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCreditCard", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CreditCard GetCreditCard(int creditCardId);

        /// <summary>
        /// get list of entities 'CreditCardList' using a Where clause
		/// Database Table CreditCard
        /// </summary>
        /// <returns>Entity 'CreditCardList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCreditCardList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CreditCardList GetCreditCardList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'CreditCard', accourding to entity content and state.
		/// Database Table CreditCard
        /// </summary>
        /// <returns>Entity 'CreditCard', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveCreditCard", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CreditCard SaveCreditCard(CreditCard item);

        /// <summary>
        /// Remove existing entity 'CreditCard'
		/// Database Table CreditCard
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveCreditCard", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveCreditCard(CreditCard item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetCreditCard" />
		/// Database Table CreditCard
        /// </summary>
        virtual public CreditCard GetCreditCard(int creditCardId)
        {
		    CreditCard result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCreditCard(creditCardId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetCreditCardList" />
		/// Database Table CreditCard
        /// </summary>
        virtual public CreditCardList GetCreditCardList(SqlWhereClause where)
        {
			CreditCardList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCreditCardList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveCreditCard" />
		/// Database Table CreditCard
        /// </summary>
        virtual public CreditCard SaveCreditCard(CreditCard item)
        {
			CreditCard result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveCreditCard(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveCreditCard" />
		/// Database Table CreditCard
        /// </summary>
        virtual public bool RemoveCreditCard(CreditCard item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveCreditCard(item);
			});
			return result;
        }
    }
}