﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'Culture' using it's primary key(s)
		/// Tabelle Culture
        /// </summary>
        /// <returns>a new object of entity 'Culture', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCulture", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Culture GetCulture(string cultureId);

        /// <summary>
        /// get list of entities 'CultureList' using a Where clause
		/// Database Table Culture
        /// </summary>
        /// <returns>Entity 'CultureList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCultureList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CultureList GetCultureList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'Culture', accourding to entity content and state.
		/// Database Table Culture
        /// </summary>
        /// <returns>Entity 'Culture', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveCulture", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Culture SaveCulture(Culture item);

        /// <summary>
        /// Remove existing entity 'Culture'
		/// Database Table Culture
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveCulture", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveCulture(Culture item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetCulture" />
		/// Database Table Culture
        /// </summary>
        virtual public Culture GetCulture(string cultureId)
        {
		    Culture result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCulture(cultureId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetCultureList" />
		/// Database Table Culture
        /// </summary>
        virtual public CultureList GetCultureList(SqlWhereClause where)
        {
			CultureList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCultureList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveCulture" />
		/// Database Table Culture
        /// </summary>
        virtual public Culture SaveCulture(Culture item)
        {
			Culture result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveCulture(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveCulture" />
		/// Database Table Culture
        /// </summary>
        virtual public bool RemoveCulture(Culture item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveCulture(item);
			});
			return result;
        }
    }
}