﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'Currency' using it's primary key(s)
		/// Tabelle Currency
        /// </summary>
        /// <returns>a new object of entity 'Currency', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCurrency", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Currency GetCurrency(string currencyCode);

        /// <summary>
        /// get list of entities 'CurrencyList' using a Where clause
		/// Database Table Currency
        /// </summary>
        /// <returns>Entity 'CurrencyList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCurrencyList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CurrencyList GetCurrencyList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'Currency', accourding to entity content and state.
		/// Database Table Currency
        /// </summary>
        /// <returns>Entity 'Currency', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveCurrency", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Currency SaveCurrency(Currency item);

        /// <summary>
        /// Remove existing entity 'Currency'
		/// Database Table Currency
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveCurrency", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveCurrency(Currency item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetCurrency" />
		/// Database Table Currency
        /// </summary>
        virtual public Currency GetCurrency(string currencyCode)
        {
		    Currency result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCurrency(currencyCode);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetCurrencyList" />
		/// Database Table Currency
        /// </summary>
        virtual public CurrencyList GetCurrencyList(SqlWhereClause where)
        {
			CurrencyList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCurrencyList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveCurrency" />
		/// Database Table Currency
        /// </summary>
        virtual public Currency SaveCurrency(Currency item)
        {
			Currency result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveCurrency(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveCurrency" />
		/// Database Table Currency
        /// </summary>
        virtual public bool RemoveCurrency(Currency item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveCurrency(item);
			});
			return result;
        }
    }
}