﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'CurrencyRate' using it's primary key(s)
		/// Tabelle CurrencyRate
        /// </summary>
        /// <returns>a new object of entity 'CurrencyRate', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCurrencyRate", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CurrencyRate GetCurrencyRate(int currencyRateId);

        /// <summary>
        /// get list of entities 'CurrencyRateList' using a Where clause
		/// Database Table CurrencyRate
        /// </summary>
        /// <returns>Entity 'CurrencyRateList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetCurrencyRateList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CurrencyRateList GetCurrencyRateList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'CurrencyRate', accourding to entity content and state.
		/// Database Table CurrencyRate
        /// </summary>
        /// <returns>Entity 'CurrencyRate', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveCurrencyRate", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        CurrencyRate SaveCurrencyRate(CurrencyRate item);

        /// <summary>
        /// Remove existing entity 'CurrencyRate'
		/// Database Table CurrencyRate
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveCurrencyRate", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveCurrencyRate(CurrencyRate item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetCurrencyRate" />
		/// Database Table CurrencyRate
        /// </summary>
        virtual public CurrencyRate GetCurrencyRate(int currencyRateId)
        {
		    CurrencyRate result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCurrencyRate(currencyRateId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetCurrencyRateList" />
		/// Database Table CurrencyRate
        /// </summary>
        virtual public CurrencyRateList GetCurrencyRateList(SqlWhereClause where)
        {
			CurrencyRateList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetCurrencyRateList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveCurrencyRate" />
		/// Database Table CurrencyRate
        /// </summary>
        virtual public CurrencyRate SaveCurrencyRate(CurrencyRate item)
        {
			CurrencyRate result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveCurrencyRate(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveCurrencyRate" />
		/// Database Table CurrencyRate
        /// </summary>
        virtual public bool RemoveCurrencyRate(CurrencyRate item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveCurrencyRate(item);
			});
			return result;
        }
    }
}