﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'DatabaseLog' using it's primary key(s)
		/// Tabelle DatabaseLog
        /// </summary>
        /// <returns>a new object of entity 'DatabaseLog', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetDatabaseLog", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        DatabaseLog GetDatabaseLog(int databaseLogId);

        /// <summary>
        /// get list of entities 'DatabaseLogList' using a Where clause
		/// Database Table DatabaseLog
        /// </summary>
        /// <returns>Entity 'DatabaseLogList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetDatabaseLogList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        DatabaseLogList GetDatabaseLogList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'DatabaseLog', accourding to entity content and state.
		/// Database Table DatabaseLog
        /// </summary>
        /// <returns>Entity 'DatabaseLog', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveDatabaseLog", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        DatabaseLog SaveDatabaseLog(DatabaseLog item);

        /// <summary>
        /// Remove existing entity 'DatabaseLog'
		/// Database Table DatabaseLog
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveDatabaseLog", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveDatabaseLog(DatabaseLog item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetDatabaseLog" />
		/// Database Table DatabaseLog
        /// </summary>
        virtual public DatabaseLog GetDatabaseLog(int databaseLogId)
        {
		    DatabaseLog result = null;
			this.Execute((manager) =>
			{
				result = manager.GetDatabaseLog(databaseLogId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetDatabaseLogList" />
		/// Database Table DatabaseLog
        /// </summary>
        virtual public DatabaseLogList GetDatabaseLogList(SqlWhereClause where)
        {
			DatabaseLogList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetDatabaseLogList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveDatabaseLog" />
		/// Database Table DatabaseLog
        /// </summary>
        virtual public DatabaseLog SaveDatabaseLog(DatabaseLog item)
        {
			DatabaseLog result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveDatabaseLog(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveDatabaseLog" />
		/// Database Table DatabaseLog
        /// </summary>
        virtual public bool RemoveDatabaseLog(DatabaseLog item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveDatabaseLog(item);
			});
			return result;
        }
    }
}