﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'Department' using it's primary key(s)
		/// Tabelle Department
        /// </summary>
        /// <returns>a new object of entity 'Department', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetDepartment", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Department GetDepartment(short departmentId);

        /// <summary>
        /// get list of entities 'DepartmentList' using a Where clause
		/// Database Table Department
        /// </summary>
        /// <returns>Entity 'DepartmentList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetDepartmentList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        DepartmentList GetDepartmentList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'Department', accourding to entity content and state.
		/// Database Table Department
        /// </summary>
        /// <returns>Entity 'Department', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveDepartment", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Department SaveDepartment(Department item);

        /// <summary>
        /// Remove existing entity 'Department'
		/// Database Table Department
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveDepartment", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveDepartment(Department item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetDepartment" />
		/// Database Table Department
        /// </summary>
        virtual public Department GetDepartment(short departmentId)
        {
		    Department result = null;
			this.Execute((manager) =>
			{
				result = manager.GetDepartment(departmentId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetDepartmentList" />
		/// Database Table Department
        /// </summary>
        virtual public DepartmentList GetDepartmentList(SqlWhereClause where)
        {
			DepartmentList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetDepartmentList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveDepartment" />
		/// Database Table Department
        /// </summary>
        virtual public Department SaveDepartment(Department item)
        {
			Department result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveDepartment(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveDepartment" />
		/// Database Table Department
        /// </summary>
        virtual public bool RemoveDepartment(Department item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveDepartment(item);
			});
			return result;
        }
    }
}