﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'EmailAddress' using it's primary key(s)
		/// Tabelle EmailAddress
        /// </summary>
        /// <returns>a new object of entity 'EmailAddress', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetEmailAddress", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        EmailAddress GetEmailAddress(int businessEntityId, int emailAddressId);

        /// <summary>
        /// get list of entities 'EmailAddressList' using a Where clause
		/// Database Table EmailAddress
        /// </summary>
        /// <returns>Entity 'EmailAddressList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetEmailAddressList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        EmailAddressList GetEmailAddressList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'EmailAddress', accourding to entity content and state.
		/// Database Table EmailAddress
        /// </summary>
        /// <returns>Entity 'EmailAddress', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveEmailAddress", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        EmailAddress SaveEmailAddress(EmailAddress item);

        /// <summary>
        /// Remove existing entity 'EmailAddress'
		/// Database Table EmailAddress
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveEmailAddress", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveEmailAddress(EmailAddress item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetEmailAddress" />
		/// Database Table EmailAddress
        /// </summary>
        virtual public EmailAddress GetEmailAddress(int businessEntityId, int emailAddressId)
        {
		    EmailAddress result = null;
			this.Execute((manager) =>
			{
				result = manager.GetEmailAddress(businessEntityId, emailAddressId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetEmailAddressList" />
		/// Database Table EmailAddress
        /// </summary>
        virtual public EmailAddressList GetEmailAddressList(SqlWhereClause where)
        {
			EmailAddressList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetEmailAddressList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveEmailAddress" />
		/// Database Table EmailAddress
        /// </summary>
        virtual public EmailAddress SaveEmailAddress(EmailAddress item)
        {
			EmailAddress result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveEmailAddress(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveEmailAddress" />
		/// Database Table EmailAddress
        /// </summary>
        virtual public bool RemoveEmailAddress(EmailAddress item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveEmailAddress(item);
			});
			return result;
        }
    }
}