﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'EmployeeDepartmentHistory' using it's primary key(s)
		/// Tabelle EmployeeDepartmentHistory
        /// </summary>
        /// <returns>a new object of entity 'EmployeeDepartmentHistory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetEmployeeDepartmentHistory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        EmployeeDepartmentHistory GetEmployeeDepartmentHistory(int businessEntityId, DateTime startDate, short departmentId, byte shiftId);

        /// <summary>
        /// get list of entities 'EmployeeDepartmentHistoryList' using a Where clause
		/// Database Table EmployeeDepartmentHistory
        /// </summary>
        /// <returns>Entity 'EmployeeDepartmentHistoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetEmployeeDepartmentHistoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        EmployeeDepartmentHistoryList GetEmployeeDepartmentHistoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'EmployeeDepartmentHistory', accourding to entity content and state.
		/// Database Table EmployeeDepartmentHistory
        /// </summary>
        /// <returns>Entity 'EmployeeDepartmentHistory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveEmployeeDepartmentHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        EmployeeDepartmentHistory SaveEmployeeDepartmentHistory(EmployeeDepartmentHistory item);

        /// <summary>
        /// Remove existing entity 'EmployeeDepartmentHistory'
		/// Database Table EmployeeDepartmentHistory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveEmployeeDepartmentHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveEmployeeDepartmentHistory(EmployeeDepartmentHistory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetEmployeeDepartmentHistory" />
		/// Database Table EmployeeDepartmentHistory
        /// </summary>
        virtual public EmployeeDepartmentHistory GetEmployeeDepartmentHistory(int businessEntityId, DateTime startDate, short departmentId, byte shiftId)
        {
		    EmployeeDepartmentHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetEmployeeDepartmentHistory(businessEntityId, startDate, departmentId, shiftId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetEmployeeDepartmentHistoryList" />
		/// Database Table EmployeeDepartmentHistory
        /// </summary>
        virtual public EmployeeDepartmentHistoryList GetEmployeeDepartmentHistoryList(SqlWhereClause where)
        {
			EmployeeDepartmentHistoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetEmployeeDepartmentHistoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveEmployeeDepartmentHistory" />
		/// Database Table EmployeeDepartmentHistory
        /// </summary>
        virtual public EmployeeDepartmentHistory SaveEmployeeDepartmentHistory(EmployeeDepartmentHistory item)
        {
			EmployeeDepartmentHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveEmployeeDepartmentHistory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveEmployeeDepartmentHistory" />
		/// Database Table EmployeeDepartmentHistory
        /// </summary>
        virtual public bool RemoveEmployeeDepartmentHistory(EmployeeDepartmentHistory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveEmployeeDepartmentHistory(item);
			});
			return result;
        }
    }
}