﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'EmployeePayHistory' using it's primary key(s)
		/// Tabelle EmployeePayHistory
        /// </summary>
        /// <returns>a new object of entity 'EmployeePayHistory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetEmployeePayHistory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        EmployeePayHistory GetEmployeePayHistory(int businessEntityId, DateTime rateChangeDate);

        /// <summary>
        /// get list of entities 'EmployeePayHistoryList' using a Where clause
		/// Database Table EmployeePayHistory
        /// </summary>
        /// <returns>Entity 'EmployeePayHistoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetEmployeePayHistoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        EmployeePayHistoryList GetEmployeePayHistoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'EmployeePayHistory', accourding to entity content and state.
		/// Database Table EmployeePayHistory
        /// </summary>
        /// <returns>Entity 'EmployeePayHistory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveEmployeePayHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        EmployeePayHistory SaveEmployeePayHistory(EmployeePayHistory item);

        /// <summary>
        /// Remove existing entity 'EmployeePayHistory'
		/// Database Table EmployeePayHistory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveEmployeePayHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveEmployeePayHistory(EmployeePayHistory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetEmployeePayHistory" />
		/// Database Table EmployeePayHistory
        /// </summary>
        virtual public EmployeePayHistory GetEmployeePayHistory(int businessEntityId, DateTime rateChangeDate)
        {
		    EmployeePayHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetEmployeePayHistory(businessEntityId, rateChangeDate);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetEmployeePayHistoryList" />
		/// Database Table EmployeePayHistory
        /// </summary>
        virtual public EmployeePayHistoryList GetEmployeePayHistoryList(SqlWhereClause where)
        {
			EmployeePayHistoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetEmployeePayHistoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveEmployeePayHistory" />
		/// Database Table EmployeePayHistory
        /// </summary>
        virtual public EmployeePayHistory SaveEmployeePayHistory(EmployeePayHistory item)
        {
			EmployeePayHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveEmployeePayHistory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveEmployeePayHistory" />
		/// Database Table EmployeePayHistory
        /// </summary>
        virtual public bool RemoveEmployeePayHistory(EmployeePayHistory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveEmployeePayHistory(item);
			});
			return result;
        }
    }
}