﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ErrorLog' using it's primary key(s)
		/// Tabelle ErrorLog
        /// </summary>
        /// <returns>a new object of entity 'ErrorLog', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetErrorLog", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ErrorLog GetErrorLog(int errorLogId);

        /// <summary>
        /// get list of entities 'ErrorLogList' using a Where clause
		/// Database Table ErrorLog
        /// </summary>
        /// <returns>Entity 'ErrorLogList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetErrorLogList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ErrorLogList GetErrorLogList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ErrorLog', accourding to entity content and state.
		/// Database Table ErrorLog
        /// </summary>
        /// <returns>Entity 'ErrorLog', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveErrorLog", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ErrorLog SaveErrorLog(ErrorLog item);

        /// <summary>
        /// Remove existing entity 'ErrorLog'
		/// Database Table ErrorLog
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveErrorLog", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveErrorLog(ErrorLog item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetErrorLog" />
		/// Database Table ErrorLog
        /// </summary>
        virtual public ErrorLog GetErrorLog(int errorLogId)
        {
		    ErrorLog result = null;
			this.Execute((manager) =>
			{
				result = manager.GetErrorLog(errorLogId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetErrorLogList" />
		/// Database Table ErrorLog
        /// </summary>
        virtual public ErrorLogList GetErrorLogList(SqlWhereClause where)
        {
			ErrorLogList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetErrorLogList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveErrorLog" />
		/// Database Table ErrorLog
        /// </summary>
        virtual public ErrorLog SaveErrorLog(ErrorLog item)
        {
			ErrorLog result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveErrorLog(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveErrorLog" />
		/// Database Table ErrorLog
        /// </summary>
        virtual public bool RemoveErrorLog(ErrorLog item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveErrorLog(item);
			});
			return result;
        }
    }
}