﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'Illustration' using it's primary key(s)
		/// Tabelle Illustration
        /// </summary>
        /// <returns>a new object of entity 'Illustration', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetIllustration", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Illustration GetIllustration(int illustrationId);

        /// <summary>
        /// get list of entities 'IllustrationList' using a Where clause
		/// Database Table Illustration
        /// </summary>
        /// <returns>Entity 'IllustrationList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetIllustrationList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        IllustrationList GetIllustrationList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'Illustration', accourding to entity content and state.
		/// Database Table Illustration
        /// </summary>
        /// <returns>Entity 'Illustration', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveIllustration", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Illustration SaveIllustration(Illustration item);

        /// <summary>
        /// Remove existing entity 'Illustration'
		/// Database Table Illustration
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveIllustration", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveIllustration(Illustration item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetIllustration" />
		/// Database Table Illustration
        /// </summary>
        virtual public Illustration GetIllustration(int illustrationId)
        {
		    Illustration result = null;
			this.Execute((manager) =>
			{
				result = manager.GetIllustration(illustrationId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetIllustrationList" />
		/// Database Table Illustration
        /// </summary>
        virtual public IllustrationList GetIllustrationList(SqlWhereClause where)
        {
			IllustrationList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetIllustrationList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveIllustration" />
		/// Database Table Illustration
        /// </summary>
        virtual public Illustration SaveIllustration(Illustration item)
        {
			Illustration result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveIllustration(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveIllustration" />
		/// Database Table Illustration
        /// </summary>
        virtual public bool RemoveIllustration(Illustration item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveIllustration(item);
			});
			return result;
        }
    }
}