﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'JobCandidate' using it's primary key(s)
		/// Tabelle JobCandidate
        /// </summary>
        /// <returns>a new object of entity 'JobCandidate', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetJobCandidate", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        JobCandidate GetJobCandidate(int jobCandidateId);

        /// <summary>
        /// get list of entities 'JobCandidateList' using a Where clause
		/// Database Table JobCandidate
        /// </summary>
        /// <returns>Entity 'JobCandidateList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetJobCandidateList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        JobCandidateList GetJobCandidateList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'JobCandidate', accourding to entity content and state.
		/// Database Table JobCandidate
        /// </summary>
        /// <returns>Entity 'JobCandidate', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveJobCandidate", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        JobCandidate SaveJobCandidate(JobCandidate item);

        /// <summary>
        /// Remove existing entity 'JobCandidate'
		/// Database Table JobCandidate
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveJobCandidate", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveJobCandidate(JobCandidate item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetJobCandidate" />
		/// Database Table JobCandidate
        /// </summary>
        virtual public JobCandidate GetJobCandidate(int jobCandidateId)
        {
		    JobCandidate result = null;
			this.Execute((manager) =>
			{
				result = manager.GetJobCandidate(jobCandidateId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetJobCandidateList" />
		/// Database Table JobCandidate
        /// </summary>
        virtual public JobCandidateList GetJobCandidateList(SqlWhereClause where)
        {
			JobCandidateList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetJobCandidateList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveJobCandidate" />
		/// Database Table JobCandidate
        /// </summary>
        virtual public JobCandidate SaveJobCandidate(JobCandidate item)
        {
			JobCandidate result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveJobCandidate(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveJobCandidate" />
		/// Database Table JobCandidate
        /// </summary>
        virtual public bool RemoveJobCandidate(JobCandidate item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveJobCandidate(item);
			});
			return result;
        }
    }
}