﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'Location' using it's primary key(s)
		/// Tabelle Location
        /// </summary>
        /// <returns>a new object of entity 'Location', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetLocation", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Location GetLocation(short locationId);

        /// <summary>
        /// get list of entities 'LocationList' using a Where clause
		/// Database Table Location
        /// </summary>
        /// <returns>Entity 'LocationList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetLocationList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        LocationList GetLocationList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'Location', accourding to entity content and state.
		/// Database Table Location
        /// </summary>
        /// <returns>Entity 'Location', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveLocation", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Location SaveLocation(Location item);

        /// <summary>
        /// Remove existing entity 'Location'
		/// Database Table Location
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveLocation", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveLocation(Location item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetLocation" />
		/// Database Table Location
        /// </summary>
        virtual public Location GetLocation(short locationId)
        {
		    Location result = null;
			this.Execute((manager) =>
			{
				result = manager.GetLocation(locationId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetLocationList" />
		/// Database Table Location
        /// </summary>
        virtual public LocationList GetLocationList(SqlWhereClause where)
        {
			LocationList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetLocationList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveLocation" />
		/// Database Table Location
        /// </summary>
        virtual public Location SaveLocation(Location item)
        {
			Location result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveLocation(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveLocation" />
		/// Database Table Location
        /// </summary>
        virtual public bool RemoveLocation(Location item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveLocation(item);
			});
			return result;
        }
    }
}