﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'Password' using it's primary key(s)
		/// Tabelle Password
        /// </summary>
        /// <returns>a new object of entity 'Password', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPassword", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Password GetPassword(int businessEntityId);

        /// <summary>
        /// get list of entities 'PasswordList' using a Where clause
		/// Database Table Password
        /// </summary>
        /// <returns>Entity 'PasswordList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPasswordList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PasswordList GetPasswordList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'Password', accourding to entity content and state.
		/// Database Table Password
        /// </summary>
        /// <returns>Entity 'Password', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SavePassword", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Password SavePassword(Password item);

        /// <summary>
        /// Remove existing entity 'Password'
		/// Database Table Password
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemovePassword", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemovePassword(Password item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetPassword" />
		/// Database Table Password
        /// </summary>
        virtual public Password GetPassword(int businessEntityId)
        {
		    Password result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPassword(businessEntityId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetPasswordList" />
		/// Database Table Password
        /// </summary>
        virtual public PasswordList GetPasswordList(SqlWhereClause where)
        {
			PasswordList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPasswordList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SavePassword" />
		/// Database Table Password
        /// </summary>
        virtual public Password SavePassword(Password item)
        {
			Password result = null;
			this.Execute((manager) =>
			{
				result = manager.SavePassword(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemovePassword" />
		/// Database Table Password
        /// </summary>
        virtual public bool RemovePassword(Password item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemovePassword(item);
			});
			return result;
        }
    }
}