﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'PersonCreditCard' using it's primary key(s)
		/// Tabelle PersonCreditCard
        /// </summary>
        /// <returns>a new object of entity 'PersonCreditCard', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPersonCreditCard", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PersonCreditCard GetPersonCreditCard(int businessEntityId, int creditCardId);

        /// <summary>
        /// get list of entities 'PersonCreditCardList' using a Where clause
		/// Database Table PersonCreditCard
        /// </summary>
        /// <returns>Entity 'PersonCreditCardList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPersonCreditCardList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PersonCreditCardList GetPersonCreditCardList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'PersonCreditCard', accourding to entity content and state.
		/// Database Table PersonCreditCard
        /// </summary>
        /// <returns>Entity 'PersonCreditCard', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SavePersonCreditCard", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PersonCreditCard SavePersonCreditCard(PersonCreditCard item);

        /// <summary>
        /// Remove existing entity 'PersonCreditCard'
		/// Database Table PersonCreditCard
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemovePersonCreditCard", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemovePersonCreditCard(PersonCreditCard item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetPersonCreditCard" />
		/// Database Table PersonCreditCard
        /// </summary>
        virtual public PersonCreditCard GetPersonCreditCard(int businessEntityId, int creditCardId)
        {
		    PersonCreditCard result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPersonCreditCard(businessEntityId, creditCardId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetPersonCreditCardList" />
		/// Database Table PersonCreditCard
        /// </summary>
        virtual public PersonCreditCardList GetPersonCreditCardList(SqlWhereClause where)
        {
			PersonCreditCardList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPersonCreditCardList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SavePersonCreditCard" />
		/// Database Table PersonCreditCard
        /// </summary>
        virtual public PersonCreditCard SavePersonCreditCard(PersonCreditCard item)
        {
			PersonCreditCard result = null;
			this.Execute((manager) =>
			{
				result = manager.SavePersonCreditCard(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemovePersonCreditCard" />
		/// Database Table PersonCreditCard
        /// </summary>
        virtual public bool RemovePersonCreditCard(PersonCreditCard item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemovePersonCreditCard(item);
			});
			return result;
        }
    }
}