﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'PersonPhone' using it's primary key(s)
		/// Tabelle PersonPhone
        /// </summary>
        /// <returns>a new object of entity 'PersonPhone', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPersonPhone", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PersonPhone GetPersonPhone(int businessEntityId, string phoneNumber, int phoneNumberTypeId);

        /// <summary>
        /// get list of entities 'PersonPhoneList' using a Where clause
		/// Database Table PersonPhone
        /// </summary>
        /// <returns>Entity 'PersonPhoneList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPersonPhoneList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PersonPhoneList GetPersonPhoneList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'PersonPhone', accourding to entity content and state.
		/// Database Table PersonPhone
        /// </summary>
        /// <returns>Entity 'PersonPhone', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SavePersonPhone", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PersonPhone SavePersonPhone(PersonPhone item);

        /// <summary>
        /// Remove existing entity 'PersonPhone'
		/// Database Table PersonPhone
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemovePersonPhone", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemovePersonPhone(PersonPhone item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetPersonPhone" />
		/// Database Table PersonPhone
        /// </summary>
        virtual public PersonPhone GetPersonPhone(int businessEntityId, string phoneNumber, int phoneNumberTypeId)
        {
		    PersonPhone result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPersonPhone(businessEntityId, phoneNumber, phoneNumberTypeId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetPersonPhoneList" />
		/// Database Table PersonPhone
        /// </summary>
        virtual public PersonPhoneList GetPersonPhoneList(SqlWhereClause where)
        {
			PersonPhoneList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPersonPhoneList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SavePersonPhone" />
		/// Database Table PersonPhone
        /// </summary>
        virtual public PersonPhone SavePersonPhone(PersonPhone item)
        {
			PersonPhone result = null;
			this.Execute((manager) =>
			{
				result = manager.SavePersonPhone(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemovePersonPhone" />
		/// Database Table PersonPhone
        /// </summary>
        virtual public bool RemovePersonPhone(PersonPhone item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemovePersonPhone(item);
			});
			return result;
        }
    }
}