﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'PhoneNumberType' using it's primary key(s)
		/// Tabelle PhoneNumberType
        /// </summary>
        /// <returns>a new object of entity 'PhoneNumberType', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPhoneNumberType", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PhoneNumberType GetPhoneNumberType(int phoneNumberTypeId);

        /// <summary>
        /// get list of entities 'PhoneNumberTypeList' using a Where clause
		/// Database Table PhoneNumberType
        /// </summary>
        /// <returns>Entity 'PhoneNumberTypeList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPhoneNumberTypeList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PhoneNumberTypeList GetPhoneNumberTypeList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'PhoneNumberType', accourding to entity content and state.
		/// Database Table PhoneNumberType
        /// </summary>
        /// <returns>Entity 'PhoneNumberType', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SavePhoneNumberType", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PhoneNumberType SavePhoneNumberType(PhoneNumberType item);

        /// <summary>
        /// Remove existing entity 'PhoneNumberType'
		/// Database Table PhoneNumberType
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemovePhoneNumberType", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemovePhoneNumberType(PhoneNumberType item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetPhoneNumberType" />
		/// Database Table PhoneNumberType
        /// </summary>
        virtual public PhoneNumberType GetPhoneNumberType(int phoneNumberTypeId)
        {
		    PhoneNumberType result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPhoneNumberType(phoneNumberTypeId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetPhoneNumberTypeList" />
		/// Database Table PhoneNumberType
        /// </summary>
        virtual public PhoneNumberTypeList GetPhoneNumberTypeList(SqlWhereClause where)
        {
			PhoneNumberTypeList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPhoneNumberTypeList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SavePhoneNumberType" />
		/// Database Table PhoneNumberType
        /// </summary>
        virtual public PhoneNumberType SavePhoneNumberType(PhoneNumberType item)
        {
			PhoneNumberType result = null;
			this.Execute((manager) =>
			{
				result = manager.SavePhoneNumberType(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemovePhoneNumberType" />
		/// Database Table PhoneNumberType
        /// </summary>
        virtual public bool RemovePhoneNumberType(PhoneNumberType item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemovePhoneNumberType(item);
			});
			return result;
        }
    }
}