﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductCategory' using it's primary key(s)
		/// Tabelle ProductCategory
        /// </summary>
        /// <returns>a new object of entity 'ProductCategory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductCategory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductCategory GetProductCategory(int productCategoryId);

        /// <summary>
        /// get list of entities 'ProductCategoryList' using a Where clause
		/// Database Table ProductCategory
        /// </summary>
        /// <returns>Entity 'ProductCategoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductCategoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductCategoryList GetProductCategoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductCategory', accourding to entity content and state.
		/// Database Table ProductCategory
        /// </summary>
        /// <returns>Entity 'ProductCategory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductCategory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductCategory SaveProductCategory(ProductCategory item);

        /// <summary>
        /// Remove existing entity 'ProductCategory'
		/// Database Table ProductCategory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductCategory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductCategory(ProductCategory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductCategory" />
		/// Database Table ProductCategory
        /// </summary>
        virtual public ProductCategory GetProductCategory(int productCategoryId)
        {
		    ProductCategory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductCategory(productCategoryId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductCategoryList" />
		/// Database Table ProductCategory
        /// </summary>
        virtual public ProductCategoryList GetProductCategoryList(SqlWhereClause where)
        {
			ProductCategoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductCategoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductCategory" />
		/// Database Table ProductCategory
        /// </summary>
        virtual public ProductCategory SaveProductCategory(ProductCategory item)
        {
			ProductCategory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductCategory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductCategory" />
		/// Database Table ProductCategory
        /// </summary>
        virtual public bool RemoveProductCategory(ProductCategory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductCategory(item);
			});
			return result;
        }
    }
}