﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductCostHistory' using it's primary key(s)
		/// Tabelle ProductCostHistory
        /// </summary>
        /// <returns>a new object of entity 'ProductCostHistory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductCostHistory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductCostHistory GetProductCostHistory(int productId, DateTime startDate);

        /// <summary>
        /// get list of entities 'ProductCostHistoryList' using a Where clause
		/// Database Table ProductCostHistory
        /// </summary>
        /// <returns>Entity 'ProductCostHistoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductCostHistoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductCostHistoryList GetProductCostHistoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductCostHistory', accourding to entity content and state.
		/// Database Table ProductCostHistory
        /// </summary>
        /// <returns>Entity 'ProductCostHistory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductCostHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductCostHistory SaveProductCostHistory(ProductCostHistory item);

        /// <summary>
        /// Remove existing entity 'ProductCostHistory'
		/// Database Table ProductCostHistory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductCostHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductCostHistory(ProductCostHistory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductCostHistory" />
		/// Database Table ProductCostHistory
        /// </summary>
        virtual public ProductCostHistory GetProductCostHistory(int productId, DateTime startDate)
        {
		    ProductCostHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductCostHistory(productId, startDate);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductCostHistoryList" />
		/// Database Table ProductCostHistory
        /// </summary>
        virtual public ProductCostHistoryList GetProductCostHistoryList(SqlWhereClause where)
        {
			ProductCostHistoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductCostHistoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductCostHistory" />
		/// Database Table ProductCostHistory
        /// </summary>
        virtual public ProductCostHistory SaveProductCostHistory(ProductCostHistory item)
        {
			ProductCostHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductCostHistory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductCostHistory" />
		/// Database Table ProductCostHistory
        /// </summary>
        virtual public bool RemoveProductCostHistory(ProductCostHistory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductCostHistory(item);
			});
			return result;
        }
    }
}