﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductDescription' using it's primary key(s)
		/// Tabelle ProductDescription
        /// </summary>
        /// <returns>a new object of entity 'ProductDescription', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductDescription", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductDescription GetProductDescription(int productDescriptionId);

        /// <summary>
        /// get list of entities 'ProductDescriptionList' using a Where clause
		/// Database Table ProductDescription
        /// </summary>
        /// <returns>Entity 'ProductDescriptionList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductDescriptionList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductDescriptionList GetProductDescriptionList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductDescription', accourding to entity content and state.
		/// Database Table ProductDescription
        /// </summary>
        /// <returns>Entity 'ProductDescription', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductDescription", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductDescription SaveProductDescription(ProductDescription item);

        /// <summary>
        /// Remove existing entity 'ProductDescription'
		/// Database Table ProductDescription
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductDescription", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductDescription(ProductDescription item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductDescription" />
		/// Database Table ProductDescription
        /// </summary>
        virtual public ProductDescription GetProductDescription(int productDescriptionId)
        {
		    ProductDescription result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductDescription(productDescriptionId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductDescriptionList" />
		/// Database Table ProductDescription
        /// </summary>
        virtual public ProductDescriptionList GetProductDescriptionList(SqlWhereClause where)
        {
			ProductDescriptionList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductDescriptionList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductDescription" />
		/// Database Table ProductDescription
        /// </summary>
        virtual public ProductDescription SaveProductDescription(ProductDescription item)
        {
			ProductDescription result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductDescription(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductDescription" />
		/// Database Table ProductDescription
        /// </summary>
        virtual public bool RemoveProductDescription(ProductDescription item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductDescription(item);
			});
			return result;
        }
    }
}