﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductDocument' using it's primary key(s)
		/// Tabelle ProductDocument
        /// </summary>
        /// <returns>a new object of entity 'ProductDocument', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductDocument", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductDocument GetProductDocument(int productId, string documentNode);

        /// <summary>
        /// get list of entities 'ProductDocumentList' using a Where clause
		/// Database Table ProductDocument
        /// </summary>
        /// <returns>Entity 'ProductDocumentList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductDocumentList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductDocumentList GetProductDocumentList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductDocument', accourding to entity content and state.
		/// Database Table ProductDocument
        /// </summary>
        /// <returns>Entity 'ProductDocument', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductDocument", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductDocument SaveProductDocument(ProductDocument item);

        /// <summary>
        /// Remove existing entity 'ProductDocument'
		/// Database Table ProductDocument
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductDocument", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductDocument(ProductDocument item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductDocument" />
		/// Database Table ProductDocument
        /// </summary>
        virtual public ProductDocument GetProductDocument(int productId, string documentNode)
        {
		    ProductDocument result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductDocument(productId, documentNode);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductDocumentList" />
		/// Database Table ProductDocument
        /// </summary>
        virtual public ProductDocumentList GetProductDocumentList(SqlWhereClause where)
        {
			ProductDocumentList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductDocumentList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductDocument" />
		/// Database Table ProductDocument
        /// </summary>
        virtual public ProductDocument SaveProductDocument(ProductDocument item)
        {
			ProductDocument result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductDocument(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductDocument" />
		/// Database Table ProductDocument
        /// </summary>
        virtual public bool RemoveProductDocument(ProductDocument item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductDocument(item);
			});
			return result;
        }
    }
}