﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductInventory' using it's primary key(s)
		/// Tabelle ProductInventory
        /// </summary>
        /// <returns>a new object of entity 'ProductInventory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductInventory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductInventory GetProductInventory(int productId, short locationId);

        /// <summary>
        /// get list of entities 'ProductInventoryList' using a Where clause
		/// Database Table ProductInventory
        /// </summary>
        /// <returns>Entity 'ProductInventoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductInventoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductInventoryList GetProductInventoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductInventory', accourding to entity content and state.
		/// Database Table ProductInventory
        /// </summary>
        /// <returns>Entity 'ProductInventory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductInventory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductInventory SaveProductInventory(ProductInventory item);

        /// <summary>
        /// Remove existing entity 'ProductInventory'
		/// Database Table ProductInventory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductInventory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductInventory(ProductInventory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductInventory" />
		/// Database Table ProductInventory
        /// </summary>
        virtual public ProductInventory GetProductInventory(int productId, short locationId)
        {
		    ProductInventory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductInventory(productId, locationId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductInventoryList" />
		/// Database Table ProductInventory
        /// </summary>
        virtual public ProductInventoryList GetProductInventoryList(SqlWhereClause where)
        {
			ProductInventoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductInventoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductInventory" />
		/// Database Table ProductInventory
        /// </summary>
        virtual public ProductInventory SaveProductInventory(ProductInventory item)
        {
			ProductInventory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductInventory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductInventory" />
		/// Database Table ProductInventory
        /// </summary>
        virtual public bool RemoveProductInventory(ProductInventory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductInventory(item);
			});
			return result;
        }
    }
}