﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductListPriceHistory' using it's primary key(s)
		/// Tabelle ProductListPriceHistory
        /// </summary>
        /// <returns>a new object of entity 'ProductListPriceHistory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductListPriceHistory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductListPriceHistory GetProductListPriceHistory(int productId, DateTime startDate);

        /// <summary>
        /// get list of entities 'ProductListPriceHistoryList' using a Where clause
		/// Database Table ProductListPriceHistory
        /// </summary>
        /// <returns>Entity 'ProductListPriceHistoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductListPriceHistoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductListPriceHistoryList GetProductListPriceHistoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductListPriceHistory', accourding to entity content and state.
		/// Database Table ProductListPriceHistory
        /// </summary>
        /// <returns>Entity 'ProductListPriceHistory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductListPriceHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductListPriceHistory SaveProductListPriceHistory(ProductListPriceHistory item);

        /// <summary>
        /// Remove existing entity 'ProductListPriceHistory'
		/// Database Table ProductListPriceHistory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductListPriceHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductListPriceHistory(ProductListPriceHistory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductListPriceHistory" />
		/// Database Table ProductListPriceHistory
        /// </summary>
        virtual public ProductListPriceHistory GetProductListPriceHistory(int productId, DateTime startDate)
        {
		    ProductListPriceHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductListPriceHistory(productId, startDate);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductListPriceHistoryList" />
		/// Database Table ProductListPriceHistory
        /// </summary>
        virtual public ProductListPriceHistoryList GetProductListPriceHistoryList(SqlWhereClause where)
        {
			ProductListPriceHistoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductListPriceHistoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductListPriceHistory" />
		/// Database Table ProductListPriceHistory
        /// </summary>
        virtual public ProductListPriceHistory SaveProductListPriceHistory(ProductListPriceHistory item)
        {
			ProductListPriceHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductListPriceHistory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductListPriceHistory" />
		/// Database Table ProductListPriceHistory
        /// </summary>
        virtual public bool RemoveProductListPriceHistory(ProductListPriceHistory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductListPriceHistory(item);
			});
			return result;
        }
    }
}