﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductModel' using it's primary key(s)
		/// Tabelle ProductModel
        /// </summary>
        /// <returns>a new object of entity 'ProductModel', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductModel", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductModel GetProductModel(int productModelId);

        /// <summary>
        /// get list of entities 'ProductModelList' using a Where clause
		/// Database Table ProductModel
        /// </summary>
        /// <returns>Entity 'ProductModelList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductModelList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductModelList GetProductModelList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductModel', accourding to entity content and state.
		/// Database Table ProductModel
        /// </summary>
        /// <returns>Entity 'ProductModel', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductModel", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductModel SaveProductModel(ProductModel item);

        /// <summary>
        /// Remove existing entity 'ProductModel'
		/// Database Table ProductModel
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductModel", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductModel(ProductModel item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductModel" />
		/// Database Table ProductModel
        /// </summary>
        virtual public ProductModel GetProductModel(int productModelId)
        {
		    ProductModel result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductModel(productModelId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductModelList" />
		/// Database Table ProductModel
        /// </summary>
        virtual public ProductModelList GetProductModelList(SqlWhereClause where)
        {
			ProductModelList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductModelList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductModel" />
		/// Database Table ProductModel
        /// </summary>
        virtual public ProductModel SaveProductModel(ProductModel item)
        {
			ProductModel result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductModel(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductModel" />
		/// Database Table ProductModel
        /// </summary>
        virtual public bool RemoveProductModel(ProductModel item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductModel(item);
			});
			return result;
        }
    }
}