﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductModelIllustration' using it's primary key(s)
		/// Tabelle ProductModelIllustration
        /// </summary>
        /// <returns>a new object of entity 'ProductModelIllustration', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductModelIllustration", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductModelIllustration GetProductModelIllustration(int productModelId, int illustrationId);

        /// <summary>
        /// get list of entities 'ProductModelIllustrationList' using a Where clause
		/// Database Table ProductModelIllustration
        /// </summary>
        /// <returns>Entity 'ProductModelIllustrationList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductModelIllustrationList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductModelIllustrationList GetProductModelIllustrationList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductModelIllustration', accourding to entity content and state.
		/// Database Table ProductModelIllustration
        /// </summary>
        /// <returns>Entity 'ProductModelIllustration', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductModelIllustration", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductModelIllustration SaveProductModelIllustration(ProductModelIllustration item);

        /// <summary>
        /// Remove existing entity 'ProductModelIllustration'
		/// Database Table ProductModelIllustration
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductModelIllustration", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductModelIllustration(ProductModelIllustration item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductModelIllustration" />
		/// Database Table ProductModelIllustration
        /// </summary>
        virtual public ProductModelIllustration GetProductModelIllustration(int productModelId, int illustrationId)
        {
		    ProductModelIllustration result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductModelIllustration(productModelId, illustrationId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductModelIllustrationList" />
		/// Database Table ProductModelIllustration
        /// </summary>
        virtual public ProductModelIllustrationList GetProductModelIllustrationList(SqlWhereClause where)
        {
			ProductModelIllustrationList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductModelIllustrationList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductModelIllustration" />
		/// Database Table ProductModelIllustration
        /// </summary>
        virtual public ProductModelIllustration SaveProductModelIllustration(ProductModelIllustration item)
        {
			ProductModelIllustration result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductModelIllustration(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductModelIllustration" />
		/// Database Table ProductModelIllustration
        /// </summary>
        virtual public bool RemoveProductModelIllustration(ProductModelIllustration item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductModelIllustration(item);
			});
			return result;
        }
    }
}