﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductModelProductDescriptionCulture' using it's primary key(s)
		/// Tabelle ProductModelProductDescriptionCulture
        /// </summary>
        /// <returns>a new object of entity 'ProductModelProductDescriptionCulture', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductModelProductDescriptionCulture", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductModelProductDescriptionCulture GetProductModelProductDescriptionCulture(int productModelId, int productDescriptionId, string cultureId);

        /// <summary>
        /// get list of entities 'ProductModelProductDescriptionCultureList' using a Where clause
		/// Database Table ProductModelProductDescriptionCulture
        /// </summary>
        /// <returns>Entity 'ProductModelProductDescriptionCultureList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductModelProductDescriptionCultureList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductModelProductDescriptionCultureList GetProductModelProductDescriptionCultureList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductModelProductDescriptionCulture', accourding to entity content and state.
		/// Database Table ProductModelProductDescriptionCulture
        /// </summary>
        /// <returns>Entity 'ProductModelProductDescriptionCulture', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductModelProductDescriptionCulture", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductModelProductDescriptionCulture SaveProductModelProductDescriptionCulture(ProductModelProductDescriptionCulture item);

        /// <summary>
        /// Remove existing entity 'ProductModelProductDescriptionCulture'
		/// Database Table ProductModelProductDescriptionCulture
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductModelProductDescriptionCulture", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductModelProductDescriptionCulture(ProductModelProductDescriptionCulture item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductModelProductDescriptionCulture" />
		/// Database Table ProductModelProductDescriptionCulture
        /// </summary>
        virtual public ProductModelProductDescriptionCulture GetProductModelProductDescriptionCulture(int productModelId, int productDescriptionId, string cultureId)
        {
		    ProductModelProductDescriptionCulture result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductModelProductDescriptionCulture(productModelId, productDescriptionId, cultureId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductModelProductDescriptionCultureList" />
		/// Database Table ProductModelProductDescriptionCulture
        /// </summary>
        virtual public ProductModelProductDescriptionCultureList GetProductModelProductDescriptionCultureList(SqlWhereClause where)
        {
			ProductModelProductDescriptionCultureList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductModelProductDescriptionCultureList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductModelProductDescriptionCulture" />
		/// Database Table ProductModelProductDescriptionCulture
        /// </summary>
        virtual public ProductModelProductDescriptionCulture SaveProductModelProductDescriptionCulture(ProductModelProductDescriptionCulture item)
        {
			ProductModelProductDescriptionCulture result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductModelProductDescriptionCulture(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductModelProductDescriptionCulture" />
		/// Database Table ProductModelProductDescriptionCulture
        /// </summary>
        virtual public bool RemoveProductModelProductDescriptionCulture(ProductModelProductDescriptionCulture item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductModelProductDescriptionCulture(item);
			});
			return result;
        }
    }
}