﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductPhoto' using it's primary key(s)
		/// Tabelle ProductPhoto
        /// </summary>
        /// <returns>a new object of entity 'ProductPhoto', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductPhoto", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductPhoto GetProductPhoto(int productPhotoId);

        /// <summary>
        /// get list of entities 'ProductPhotoList' using a Where clause
		/// Database Table ProductPhoto
        /// </summary>
        /// <returns>Entity 'ProductPhotoList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductPhotoList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductPhotoList GetProductPhotoList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductPhoto', accourding to entity content and state.
		/// Database Table ProductPhoto
        /// </summary>
        /// <returns>Entity 'ProductPhoto', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductPhoto", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductPhoto SaveProductPhoto(ProductPhoto item);

        /// <summary>
        /// Remove existing entity 'ProductPhoto'
		/// Database Table ProductPhoto
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductPhoto", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductPhoto(ProductPhoto item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductPhoto" />
		/// Database Table ProductPhoto
        /// </summary>
        virtual public ProductPhoto GetProductPhoto(int productPhotoId)
        {
		    ProductPhoto result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductPhoto(productPhotoId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductPhotoList" />
		/// Database Table ProductPhoto
        /// </summary>
        virtual public ProductPhotoList GetProductPhotoList(SqlWhereClause where)
        {
			ProductPhotoList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductPhotoList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductPhoto" />
		/// Database Table ProductPhoto
        /// </summary>
        virtual public ProductPhoto SaveProductPhoto(ProductPhoto item)
        {
			ProductPhoto result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductPhoto(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductPhoto" />
		/// Database Table ProductPhoto
        /// </summary>
        virtual public bool RemoveProductPhoto(ProductPhoto item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductPhoto(item);
			});
			return result;
        }
    }
}