﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductProductPhoto' using it's primary key(s)
		/// Tabelle ProductProductPhoto
        /// </summary>
        /// <returns>a new object of entity 'ProductProductPhoto', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductProductPhoto", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductProductPhoto GetProductProductPhoto(int productId, int productPhotoId);

        /// <summary>
        /// get list of entities 'ProductProductPhotoList' using a Where clause
		/// Database Table ProductProductPhoto
        /// </summary>
        /// <returns>Entity 'ProductProductPhotoList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductProductPhotoList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductProductPhotoList GetProductProductPhotoList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductProductPhoto', accourding to entity content and state.
		/// Database Table ProductProductPhoto
        /// </summary>
        /// <returns>Entity 'ProductProductPhoto', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductProductPhoto", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductProductPhoto SaveProductProductPhoto(ProductProductPhoto item);

        /// <summary>
        /// Remove existing entity 'ProductProductPhoto'
		/// Database Table ProductProductPhoto
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductProductPhoto", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductProductPhoto(ProductProductPhoto item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductProductPhoto" />
		/// Database Table ProductProductPhoto
        /// </summary>
        virtual public ProductProductPhoto GetProductProductPhoto(int productId, int productPhotoId)
        {
		    ProductProductPhoto result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductProductPhoto(productId, productPhotoId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductProductPhotoList" />
		/// Database Table ProductProductPhoto
        /// </summary>
        virtual public ProductProductPhotoList GetProductProductPhotoList(SqlWhereClause where)
        {
			ProductProductPhotoList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductProductPhotoList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductProductPhoto" />
		/// Database Table ProductProductPhoto
        /// </summary>
        virtual public ProductProductPhoto SaveProductProductPhoto(ProductProductPhoto item)
        {
			ProductProductPhoto result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductProductPhoto(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductProductPhoto" />
		/// Database Table ProductProductPhoto
        /// </summary>
        virtual public bool RemoveProductProductPhoto(ProductProductPhoto item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductProductPhoto(item);
			});
			return result;
        }
    }
}