﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductReview' using it's primary key(s)
		/// Tabelle ProductReview
        /// </summary>
        /// <returns>a new object of entity 'ProductReview', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductReview", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductReview GetProductReview(int productReviewId);

        /// <summary>
        /// get list of entities 'ProductReviewList' using a Where clause
		/// Database Table ProductReview
        /// </summary>
        /// <returns>Entity 'ProductReviewList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductReviewList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductReviewList GetProductReviewList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductReview', accourding to entity content and state.
		/// Database Table ProductReview
        /// </summary>
        /// <returns>Entity 'ProductReview', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductReview", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductReview SaveProductReview(ProductReview item);

        /// <summary>
        /// Remove existing entity 'ProductReview'
		/// Database Table ProductReview
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductReview", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductReview(ProductReview item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductReview" />
		/// Database Table ProductReview
        /// </summary>
        virtual public ProductReview GetProductReview(int productReviewId)
        {
		    ProductReview result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductReview(productReviewId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductReviewList" />
		/// Database Table ProductReview
        /// </summary>
        virtual public ProductReviewList GetProductReviewList(SqlWhereClause where)
        {
			ProductReviewList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductReviewList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductReview" />
		/// Database Table ProductReview
        /// </summary>
        virtual public ProductReview SaveProductReview(ProductReview item)
        {
			ProductReview result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductReview(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductReview" />
		/// Database Table ProductReview
        /// </summary>
        virtual public bool RemoveProductReview(ProductReview item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductReview(item);
			});
			return result;
        }
    }
}