﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductSubcategory' using it's primary key(s)
		/// Tabelle ProductSubcategory
        /// </summary>
        /// <returns>a new object of entity 'ProductSubcategory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductSubcategory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductSubcategory GetProductSubcategory(int productSubcategoryId);

        /// <summary>
        /// get list of entities 'ProductSubcategoryList' using a Where clause
		/// Database Table ProductSubcategory
        /// </summary>
        /// <returns>Entity 'ProductSubcategoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductSubcategoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductSubcategoryList GetProductSubcategoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductSubcategory', accourding to entity content and state.
		/// Database Table ProductSubcategory
        /// </summary>
        /// <returns>Entity 'ProductSubcategory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductSubcategory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductSubcategory SaveProductSubcategory(ProductSubcategory item);

        /// <summary>
        /// Remove existing entity 'ProductSubcategory'
		/// Database Table ProductSubcategory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductSubcategory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductSubcategory(ProductSubcategory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductSubcategory" />
		/// Database Table ProductSubcategory
        /// </summary>
        virtual public ProductSubcategory GetProductSubcategory(int productSubcategoryId)
        {
		    ProductSubcategory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductSubcategory(productSubcategoryId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductSubcategoryList" />
		/// Database Table ProductSubcategory
        /// </summary>
        virtual public ProductSubcategoryList GetProductSubcategoryList(SqlWhereClause where)
        {
			ProductSubcategoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductSubcategoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductSubcategory" />
		/// Database Table ProductSubcategory
        /// </summary>
        virtual public ProductSubcategory SaveProductSubcategory(ProductSubcategory item)
        {
			ProductSubcategory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductSubcategory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductSubcategory" />
		/// Database Table ProductSubcategory
        /// </summary>
        virtual public bool RemoveProductSubcategory(ProductSubcategory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductSubcategory(item);
			});
			return result;
        }
    }
}