﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ProductVendor' using it's primary key(s)
		/// Tabelle ProductVendor
        /// </summary>
        /// <returns>a new object of entity 'ProductVendor', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductVendor", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductVendor GetProductVendor(int productId, int businessEntityId);

        /// <summary>
        /// get list of entities 'ProductVendorList' using a Where clause
		/// Database Table ProductVendor
        /// </summary>
        /// <returns>Entity 'ProductVendorList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetProductVendorList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductVendorList GetProductVendorList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ProductVendor', accourding to entity content and state.
		/// Database Table ProductVendor
        /// </summary>
        /// <returns>Entity 'ProductVendor', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveProductVendor", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ProductVendor SaveProductVendor(ProductVendor item);

        /// <summary>
        /// Remove existing entity 'ProductVendor'
		/// Database Table ProductVendor
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveProductVendor", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveProductVendor(ProductVendor item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetProductVendor" />
		/// Database Table ProductVendor
        /// </summary>
        virtual public ProductVendor GetProductVendor(int productId, int businessEntityId)
        {
		    ProductVendor result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductVendor(productId, businessEntityId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetProductVendorList" />
		/// Database Table ProductVendor
        /// </summary>
        virtual public ProductVendorList GetProductVendorList(SqlWhereClause where)
        {
			ProductVendorList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetProductVendorList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveProductVendor" />
		/// Database Table ProductVendor
        /// </summary>
        virtual public ProductVendor SaveProductVendor(ProductVendor item)
        {
			ProductVendor result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveProductVendor(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveProductVendor" />
		/// Database Table ProductVendor
        /// </summary>
        virtual public bool RemoveProductVendor(ProductVendor item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveProductVendor(item);
			});
			return result;
        }
    }
}