﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'PurchaseOrderDetail' using it's primary key(s)
		/// Tabelle PurchaseOrderDetail
        /// </summary>
        /// <returns>a new object of entity 'PurchaseOrderDetail', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPurchaseOrderDetail", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PurchaseOrderDetail GetPurchaseOrderDetail(int purchaseOrderId, int purchaseOrderDetailId);

        /// <summary>
        /// get list of entities 'PurchaseOrderDetailList' using a Where clause
		/// Database Table PurchaseOrderDetail
        /// </summary>
        /// <returns>Entity 'PurchaseOrderDetailList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPurchaseOrderDetailList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PurchaseOrderDetailList GetPurchaseOrderDetailList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'PurchaseOrderDetail', accourding to entity content and state.
		/// Database Table PurchaseOrderDetail
        /// </summary>
        /// <returns>Entity 'PurchaseOrderDetail', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SavePurchaseOrderDetail", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PurchaseOrderDetail SavePurchaseOrderDetail(PurchaseOrderDetail item);

        /// <summary>
        /// Remove existing entity 'PurchaseOrderDetail'
		/// Database Table PurchaseOrderDetail
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemovePurchaseOrderDetail", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemovePurchaseOrderDetail(PurchaseOrderDetail item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetPurchaseOrderDetail" />
		/// Database Table PurchaseOrderDetail
        /// </summary>
        virtual public PurchaseOrderDetail GetPurchaseOrderDetail(int purchaseOrderId, int purchaseOrderDetailId)
        {
		    PurchaseOrderDetail result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPurchaseOrderDetail(purchaseOrderId, purchaseOrderDetailId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetPurchaseOrderDetailList" />
		/// Database Table PurchaseOrderDetail
        /// </summary>
        virtual public PurchaseOrderDetailList GetPurchaseOrderDetailList(SqlWhereClause where)
        {
			PurchaseOrderDetailList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPurchaseOrderDetailList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SavePurchaseOrderDetail" />
		/// Database Table PurchaseOrderDetail
        /// </summary>
        virtual public PurchaseOrderDetail SavePurchaseOrderDetail(PurchaseOrderDetail item)
        {
			PurchaseOrderDetail result = null;
			this.Execute((manager) =>
			{
				result = manager.SavePurchaseOrderDetail(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemovePurchaseOrderDetail" />
		/// Database Table PurchaseOrderDetail
        /// </summary>
        virtual public bool RemovePurchaseOrderDetail(PurchaseOrderDetail item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemovePurchaseOrderDetail(item);
			});
			return result;
        }
    }
}