﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'PurchaseOrderHeader' using it's primary key(s)
		/// Tabelle PurchaseOrderHeader
        /// </summary>
        /// <returns>a new object of entity 'PurchaseOrderHeader', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPurchaseOrderHeader", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PurchaseOrderHeader GetPurchaseOrderHeader(int purchaseOrderId);

        /// <summary>
        /// get list of entities 'PurchaseOrderHeaderList' using a Where clause
		/// Database Table PurchaseOrderHeader
        /// </summary>
        /// <returns>Entity 'PurchaseOrderHeaderList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetPurchaseOrderHeaderList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PurchaseOrderHeaderList GetPurchaseOrderHeaderList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'PurchaseOrderHeader', accourding to entity content and state.
		/// Database Table PurchaseOrderHeader
        /// </summary>
        /// <returns>Entity 'PurchaseOrderHeader', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SavePurchaseOrderHeader", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        PurchaseOrderHeader SavePurchaseOrderHeader(PurchaseOrderHeader item);

        /// <summary>
        /// Remove existing entity 'PurchaseOrderHeader'
		/// Database Table PurchaseOrderHeader
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemovePurchaseOrderHeader", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemovePurchaseOrderHeader(PurchaseOrderHeader item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetPurchaseOrderHeader" />
		/// Database Table PurchaseOrderHeader
        /// </summary>
        virtual public PurchaseOrderHeader GetPurchaseOrderHeader(int purchaseOrderId)
        {
		    PurchaseOrderHeader result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPurchaseOrderHeader(purchaseOrderId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetPurchaseOrderHeaderList" />
		/// Database Table PurchaseOrderHeader
        /// </summary>
        virtual public PurchaseOrderHeaderList GetPurchaseOrderHeaderList(SqlWhereClause where)
        {
			PurchaseOrderHeaderList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetPurchaseOrderHeaderList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SavePurchaseOrderHeader" />
		/// Database Table PurchaseOrderHeader
        /// </summary>
        virtual public PurchaseOrderHeader SavePurchaseOrderHeader(PurchaseOrderHeader item)
        {
			PurchaseOrderHeader result = null;
			this.Execute((manager) =>
			{
				result = manager.SavePurchaseOrderHeader(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemovePurchaseOrderHeader" />
		/// Database Table PurchaseOrderHeader
        /// </summary>
        virtual public bool RemovePurchaseOrderHeader(PurchaseOrderHeader item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemovePurchaseOrderHeader(item);
			});
			return result;
        }
    }
}