﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SalesOrderDetail' using it's primary key(s)
		/// Tabelle SalesOrderDetail
        /// </summary>
        /// <returns>a new object of entity 'SalesOrderDetail', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesOrderDetail", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesOrderDetail GetSalesOrderDetail(int salesOrderId, int salesOrderDetailId);

        /// <summary>
        /// get list of entities 'SalesOrderDetailList' using a Where clause
		/// Database Table SalesOrderDetail
        /// </summary>
        /// <returns>Entity 'SalesOrderDetailList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesOrderDetailList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesOrderDetailList GetSalesOrderDetailList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SalesOrderDetail', accourding to entity content and state.
		/// Database Table SalesOrderDetail
        /// </summary>
        /// <returns>Entity 'SalesOrderDetail', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSalesOrderDetail", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesOrderDetail SaveSalesOrderDetail(SalesOrderDetail item);

        /// <summary>
        /// Remove existing entity 'SalesOrderDetail'
		/// Database Table SalesOrderDetail
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSalesOrderDetail", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSalesOrderDetail(SalesOrderDetail item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesOrderDetail" />
		/// Database Table SalesOrderDetail
        /// </summary>
        virtual public SalesOrderDetail GetSalesOrderDetail(int salesOrderId, int salesOrderDetailId)
        {
		    SalesOrderDetail result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesOrderDetail(salesOrderId, salesOrderDetailId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesOrderDetailList" />
		/// Database Table SalesOrderDetail
        /// </summary>
        virtual public SalesOrderDetailList GetSalesOrderDetailList(SqlWhereClause where)
        {
			SalesOrderDetailList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesOrderDetailList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSalesOrderDetail" />
		/// Database Table SalesOrderDetail
        /// </summary>
        virtual public SalesOrderDetail SaveSalesOrderDetail(SalesOrderDetail item)
        {
			SalesOrderDetail result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSalesOrderDetail(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSalesOrderDetail" />
		/// Database Table SalesOrderDetail
        /// </summary>
        virtual public bool RemoveSalesOrderDetail(SalesOrderDetail item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSalesOrderDetail(item);
			});
			return result;
        }
    }
}