﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SalesOrderHeader' using it's primary key(s)
		/// Tabelle SalesOrderHeader
        /// </summary>
        /// <returns>a new object of entity 'SalesOrderHeader', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesOrderHeader", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesOrderHeader GetSalesOrderHeader(int salesOrderId);

        /// <summary>
        /// get list of entities 'SalesOrderHeaderList' using a Where clause
		/// Database Table SalesOrderHeader
        /// </summary>
        /// <returns>Entity 'SalesOrderHeaderList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesOrderHeaderList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesOrderHeaderList GetSalesOrderHeaderList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SalesOrderHeader', accourding to entity content and state.
		/// Database Table SalesOrderHeader
        /// </summary>
        /// <returns>Entity 'SalesOrderHeader', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSalesOrderHeader", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesOrderHeader SaveSalesOrderHeader(SalesOrderHeader item);

        /// <summary>
        /// Remove existing entity 'SalesOrderHeader'
		/// Database Table SalesOrderHeader
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSalesOrderHeader", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSalesOrderHeader(SalesOrderHeader item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesOrderHeader" />
		/// Database Table SalesOrderHeader
        /// </summary>
        virtual public SalesOrderHeader GetSalesOrderHeader(int salesOrderId)
        {
		    SalesOrderHeader result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesOrderHeader(salesOrderId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesOrderHeaderList" />
		/// Database Table SalesOrderHeader
        /// </summary>
        virtual public SalesOrderHeaderList GetSalesOrderHeaderList(SqlWhereClause where)
        {
			SalesOrderHeaderList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesOrderHeaderList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSalesOrderHeader" />
		/// Database Table SalesOrderHeader
        /// </summary>
        virtual public SalesOrderHeader SaveSalesOrderHeader(SalesOrderHeader item)
        {
			SalesOrderHeader result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSalesOrderHeader(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSalesOrderHeader" />
		/// Database Table SalesOrderHeader
        /// </summary>
        virtual public bool RemoveSalesOrderHeader(SalesOrderHeader item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSalesOrderHeader(item);
			});
			return result;
        }
    }
}