﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SalesOrderHeaderSalesReason' using it's primary key(s)
		/// Tabelle SalesOrderHeaderSalesReason
        /// </summary>
        /// <returns>a new object of entity 'SalesOrderHeaderSalesReason', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesOrderHeaderSalesReason", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesOrderHeaderSalesReason GetSalesOrderHeaderSalesReason(int salesOrderId, int salesReasonId);

        /// <summary>
        /// get list of entities 'SalesOrderHeaderSalesReasonList' using a Where clause
		/// Database Table SalesOrderHeaderSalesReason
        /// </summary>
        /// <returns>Entity 'SalesOrderHeaderSalesReasonList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesOrderHeaderSalesReasonList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesOrderHeaderSalesReasonList GetSalesOrderHeaderSalesReasonList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SalesOrderHeaderSalesReason', accourding to entity content and state.
		/// Database Table SalesOrderHeaderSalesReason
        /// </summary>
        /// <returns>Entity 'SalesOrderHeaderSalesReason', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSalesOrderHeaderSalesReason", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesOrderHeaderSalesReason SaveSalesOrderHeaderSalesReason(SalesOrderHeaderSalesReason item);

        /// <summary>
        /// Remove existing entity 'SalesOrderHeaderSalesReason'
		/// Database Table SalesOrderHeaderSalesReason
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSalesOrderHeaderSalesReason", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSalesOrderHeaderSalesReason(SalesOrderHeaderSalesReason item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesOrderHeaderSalesReason" />
		/// Database Table SalesOrderHeaderSalesReason
        /// </summary>
        virtual public SalesOrderHeaderSalesReason GetSalesOrderHeaderSalesReason(int salesOrderId, int salesReasonId)
        {
		    SalesOrderHeaderSalesReason result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesOrderHeaderSalesReason(salesOrderId, salesReasonId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesOrderHeaderSalesReasonList" />
		/// Database Table SalesOrderHeaderSalesReason
        /// </summary>
        virtual public SalesOrderHeaderSalesReasonList GetSalesOrderHeaderSalesReasonList(SqlWhereClause where)
        {
			SalesOrderHeaderSalesReasonList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesOrderHeaderSalesReasonList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSalesOrderHeaderSalesReason" />
		/// Database Table SalesOrderHeaderSalesReason
        /// </summary>
        virtual public SalesOrderHeaderSalesReason SaveSalesOrderHeaderSalesReason(SalesOrderHeaderSalesReason item)
        {
			SalesOrderHeaderSalesReason result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSalesOrderHeaderSalesReason(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSalesOrderHeaderSalesReason" />
		/// Database Table SalesOrderHeaderSalesReason
        /// </summary>
        virtual public bool RemoveSalesOrderHeaderSalesReason(SalesOrderHeaderSalesReason item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSalesOrderHeaderSalesReason(item);
			});
			return result;
        }
    }
}