﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SalesPerson' using it's primary key(s)
		/// Tabelle SalesPerson
        /// </summary>
        /// <returns>a new object of entity 'SalesPerson', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesPerson", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesPerson GetSalesPerson(int businessEntityId);

        /// <summary>
        /// get list of entities 'SalesPersonList' using a Where clause
		/// Database Table SalesPerson
        /// </summary>
        /// <returns>Entity 'SalesPersonList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesPersonList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesPersonList GetSalesPersonList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SalesPerson', accourding to entity content and state.
		/// Database Table SalesPerson
        /// </summary>
        /// <returns>Entity 'SalesPerson', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSalesPerson", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesPerson SaveSalesPerson(SalesPerson item);

        /// <summary>
        /// Remove existing entity 'SalesPerson'
		/// Database Table SalesPerson
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSalesPerson", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSalesPerson(SalesPerson item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesPerson" />
		/// Database Table SalesPerson
        /// </summary>
        virtual public SalesPerson GetSalesPerson(int businessEntityId)
        {
		    SalesPerson result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesPerson(businessEntityId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesPersonList" />
		/// Database Table SalesPerson
        /// </summary>
        virtual public SalesPersonList GetSalesPersonList(SqlWhereClause where)
        {
			SalesPersonList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesPersonList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSalesPerson" />
		/// Database Table SalesPerson
        /// </summary>
        virtual public SalesPerson SaveSalesPerson(SalesPerson item)
        {
			SalesPerson result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSalesPerson(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSalesPerson" />
		/// Database Table SalesPerson
        /// </summary>
        virtual public bool RemoveSalesPerson(SalesPerson item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSalesPerson(item);
			});
			return result;
        }
    }
}