﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SalesPersonQuotaHistory' using it's primary key(s)
		/// Tabelle SalesPersonQuotaHistory
        /// </summary>
        /// <returns>a new object of entity 'SalesPersonQuotaHistory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesPersonQuotaHistory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesPersonQuotaHistory GetSalesPersonQuotaHistory(int businessEntityId, DateTime quotaDate);

        /// <summary>
        /// get list of entities 'SalesPersonQuotaHistoryList' using a Where clause
		/// Database Table SalesPersonQuotaHistory
        /// </summary>
        /// <returns>Entity 'SalesPersonQuotaHistoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesPersonQuotaHistoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesPersonQuotaHistoryList GetSalesPersonQuotaHistoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SalesPersonQuotaHistory', accourding to entity content and state.
		/// Database Table SalesPersonQuotaHistory
        /// </summary>
        /// <returns>Entity 'SalesPersonQuotaHistory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSalesPersonQuotaHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesPersonQuotaHistory SaveSalesPersonQuotaHistory(SalesPersonQuotaHistory item);

        /// <summary>
        /// Remove existing entity 'SalesPersonQuotaHistory'
		/// Database Table SalesPersonQuotaHistory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSalesPersonQuotaHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSalesPersonQuotaHistory(SalesPersonQuotaHistory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesPersonQuotaHistory" />
		/// Database Table SalesPersonQuotaHistory
        /// </summary>
        virtual public SalesPersonQuotaHistory GetSalesPersonQuotaHistory(int businessEntityId, DateTime quotaDate)
        {
		    SalesPersonQuotaHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesPersonQuotaHistory(businessEntityId, quotaDate);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesPersonQuotaHistoryList" />
		/// Database Table SalesPersonQuotaHistory
        /// </summary>
        virtual public SalesPersonQuotaHistoryList GetSalesPersonQuotaHistoryList(SqlWhereClause where)
        {
			SalesPersonQuotaHistoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesPersonQuotaHistoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSalesPersonQuotaHistory" />
		/// Database Table SalesPersonQuotaHistory
        /// </summary>
        virtual public SalesPersonQuotaHistory SaveSalesPersonQuotaHistory(SalesPersonQuotaHistory item)
        {
			SalesPersonQuotaHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSalesPersonQuotaHistory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSalesPersonQuotaHistory" />
		/// Database Table SalesPersonQuotaHistory
        /// </summary>
        virtual public bool RemoveSalesPersonQuotaHistory(SalesPersonQuotaHistory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSalesPersonQuotaHistory(item);
			});
			return result;
        }
    }
}