﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SalesReason' using it's primary key(s)
		/// Tabelle SalesReason
        /// </summary>
        /// <returns>a new object of entity 'SalesReason', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesReason", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesReason GetSalesReason(int salesReasonId);

        /// <summary>
        /// get list of entities 'SalesReasonList' using a Where clause
		/// Database Table SalesReason
        /// </summary>
        /// <returns>Entity 'SalesReasonList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesReasonList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesReasonList GetSalesReasonList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SalesReason', accourding to entity content and state.
		/// Database Table SalesReason
        /// </summary>
        /// <returns>Entity 'SalesReason', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSalesReason", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesReason SaveSalesReason(SalesReason item);

        /// <summary>
        /// Remove existing entity 'SalesReason'
		/// Database Table SalesReason
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSalesReason", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSalesReason(SalesReason item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesReason" />
		/// Database Table SalesReason
        /// </summary>
        virtual public SalesReason GetSalesReason(int salesReasonId)
        {
		    SalesReason result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesReason(salesReasonId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesReasonList" />
		/// Database Table SalesReason
        /// </summary>
        virtual public SalesReasonList GetSalesReasonList(SqlWhereClause where)
        {
			SalesReasonList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesReasonList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSalesReason" />
		/// Database Table SalesReason
        /// </summary>
        virtual public SalesReason SaveSalesReason(SalesReason item)
        {
			SalesReason result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSalesReason(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSalesReason" />
		/// Database Table SalesReason
        /// </summary>
        virtual public bool RemoveSalesReason(SalesReason item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSalesReason(item);
			});
			return result;
        }
    }
}