﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SalesTaxRate' using it's primary key(s)
		/// Tabelle SalesTaxRate
        /// </summary>
        /// <returns>a new object of entity 'SalesTaxRate', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesTaxRate", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesTaxRate GetSalesTaxRate(int salesTaxRateId);

        /// <summary>
        /// get list of entities 'SalesTaxRateList' using a Where clause
		/// Database Table SalesTaxRate
        /// </summary>
        /// <returns>Entity 'SalesTaxRateList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesTaxRateList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesTaxRateList GetSalesTaxRateList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SalesTaxRate', accourding to entity content and state.
		/// Database Table SalesTaxRate
        /// </summary>
        /// <returns>Entity 'SalesTaxRate', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSalesTaxRate", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesTaxRate SaveSalesTaxRate(SalesTaxRate item);

        /// <summary>
        /// Remove existing entity 'SalesTaxRate'
		/// Database Table SalesTaxRate
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSalesTaxRate", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSalesTaxRate(SalesTaxRate item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesTaxRate" />
		/// Database Table SalesTaxRate
        /// </summary>
        virtual public SalesTaxRate GetSalesTaxRate(int salesTaxRateId)
        {
		    SalesTaxRate result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesTaxRate(salesTaxRateId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesTaxRateList" />
		/// Database Table SalesTaxRate
        /// </summary>
        virtual public SalesTaxRateList GetSalesTaxRateList(SqlWhereClause where)
        {
			SalesTaxRateList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesTaxRateList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSalesTaxRate" />
		/// Database Table SalesTaxRate
        /// </summary>
        virtual public SalesTaxRate SaveSalesTaxRate(SalesTaxRate item)
        {
			SalesTaxRate result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSalesTaxRate(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSalesTaxRate" />
		/// Database Table SalesTaxRate
        /// </summary>
        virtual public bool RemoveSalesTaxRate(SalesTaxRate item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSalesTaxRate(item);
			});
			return result;
        }
    }
}