﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SalesTerritory' using it's primary key(s)
		/// Tabelle SalesTerritory
        /// </summary>
        /// <returns>a new object of entity 'SalesTerritory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesTerritory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesTerritory GetSalesTerritory(int territoryId);

        /// <summary>
        /// get list of entities 'SalesTerritoryList' using a Where clause
		/// Database Table SalesTerritory
        /// </summary>
        /// <returns>Entity 'SalesTerritoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesTerritoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesTerritoryList GetSalesTerritoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SalesTerritory', accourding to entity content and state.
		/// Database Table SalesTerritory
        /// </summary>
        /// <returns>Entity 'SalesTerritory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSalesTerritory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesTerritory SaveSalesTerritory(SalesTerritory item);

        /// <summary>
        /// Remove existing entity 'SalesTerritory'
		/// Database Table SalesTerritory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSalesTerritory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSalesTerritory(SalesTerritory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesTerritory" />
		/// Database Table SalesTerritory
        /// </summary>
        virtual public SalesTerritory GetSalesTerritory(int territoryId)
        {
		    SalesTerritory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesTerritory(territoryId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesTerritoryList" />
		/// Database Table SalesTerritory
        /// </summary>
        virtual public SalesTerritoryList GetSalesTerritoryList(SqlWhereClause where)
        {
			SalesTerritoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesTerritoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSalesTerritory" />
		/// Database Table SalesTerritory
        /// </summary>
        virtual public SalesTerritory SaveSalesTerritory(SalesTerritory item)
        {
			SalesTerritory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSalesTerritory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSalesTerritory" />
		/// Database Table SalesTerritory
        /// </summary>
        virtual public bool RemoveSalesTerritory(SalesTerritory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSalesTerritory(item);
			});
			return result;
        }
    }
}