﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SalesTerritoryHistory' using it's primary key(s)
		/// Tabelle SalesTerritoryHistory
        /// </summary>
        /// <returns>a new object of entity 'SalesTerritoryHistory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesTerritoryHistory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesTerritoryHistory GetSalesTerritoryHistory(int businessEntityId, DateTime startDate, int territoryId);

        /// <summary>
        /// get list of entities 'SalesTerritoryHistoryList' using a Where clause
		/// Database Table SalesTerritoryHistory
        /// </summary>
        /// <returns>Entity 'SalesTerritoryHistoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSalesTerritoryHistoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesTerritoryHistoryList GetSalesTerritoryHistoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SalesTerritoryHistory', accourding to entity content and state.
		/// Database Table SalesTerritoryHistory
        /// </summary>
        /// <returns>Entity 'SalesTerritoryHistory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSalesTerritoryHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SalesTerritoryHistory SaveSalesTerritoryHistory(SalesTerritoryHistory item);

        /// <summary>
        /// Remove existing entity 'SalesTerritoryHistory'
		/// Database Table SalesTerritoryHistory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSalesTerritoryHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSalesTerritoryHistory(SalesTerritoryHistory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesTerritoryHistory" />
		/// Database Table SalesTerritoryHistory
        /// </summary>
        virtual public SalesTerritoryHistory GetSalesTerritoryHistory(int businessEntityId, DateTime startDate, int territoryId)
        {
		    SalesTerritoryHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesTerritoryHistory(businessEntityId, startDate, territoryId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSalesTerritoryHistoryList" />
		/// Database Table SalesTerritoryHistory
        /// </summary>
        virtual public SalesTerritoryHistoryList GetSalesTerritoryHistoryList(SqlWhereClause where)
        {
			SalesTerritoryHistoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSalesTerritoryHistoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSalesTerritoryHistory" />
		/// Database Table SalesTerritoryHistory
        /// </summary>
        virtual public SalesTerritoryHistory SaveSalesTerritoryHistory(SalesTerritoryHistory item)
        {
			SalesTerritoryHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSalesTerritoryHistory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSalesTerritoryHistory" />
		/// Database Table SalesTerritoryHistory
        /// </summary>
        virtual public bool RemoveSalesTerritoryHistory(SalesTerritoryHistory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSalesTerritoryHistory(item);
			});
			return result;
        }
    }
}