﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ScrapReason' using it's primary key(s)
		/// Tabelle ScrapReason
        /// </summary>
        /// <returns>a new object of entity 'ScrapReason', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetScrapReason", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ScrapReason GetScrapReason(short scrapReasonId);

        /// <summary>
        /// get list of entities 'ScrapReasonList' using a Where clause
		/// Database Table ScrapReason
        /// </summary>
        /// <returns>Entity 'ScrapReasonList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetScrapReasonList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ScrapReasonList GetScrapReasonList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ScrapReason', accourding to entity content and state.
		/// Database Table ScrapReason
        /// </summary>
        /// <returns>Entity 'ScrapReason', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveScrapReason", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ScrapReason SaveScrapReason(ScrapReason item);

        /// <summary>
        /// Remove existing entity 'ScrapReason'
		/// Database Table ScrapReason
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveScrapReason", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveScrapReason(ScrapReason item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetScrapReason" />
		/// Database Table ScrapReason
        /// </summary>
        virtual public ScrapReason GetScrapReason(short scrapReasonId)
        {
		    ScrapReason result = null;
			this.Execute((manager) =>
			{
				result = manager.GetScrapReason(scrapReasonId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetScrapReasonList" />
		/// Database Table ScrapReason
        /// </summary>
        virtual public ScrapReasonList GetScrapReasonList(SqlWhereClause where)
        {
			ScrapReasonList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetScrapReasonList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveScrapReason" />
		/// Database Table ScrapReason
        /// </summary>
        virtual public ScrapReason SaveScrapReason(ScrapReason item)
        {
			ScrapReason result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveScrapReason(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveScrapReason" />
		/// Database Table ScrapReason
        /// </summary>
        virtual public bool RemoveScrapReason(ScrapReason item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveScrapReason(item);
			});
			return result;
        }
    }
}