﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'Shift' using it's primary key(s)
		/// Tabelle Shift
        /// </summary>
        /// <returns>a new object of entity 'Shift', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetShift", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Shift GetShift(byte shiftId);

        /// <summary>
        /// get list of entities 'ShiftList' using a Where clause
		/// Database Table Shift
        /// </summary>
        /// <returns>Entity 'ShiftList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetShiftList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ShiftList GetShiftList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'Shift', accourding to entity content and state.
		/// Database Table Shift
        /// </summary>
        /// <returns>Entity 'Shift', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveShift", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Shift SaveShift(Shift item);

        /// <summary>
        /// Remove existing entity 'Shift'
		/// Database Table Shift
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveShift", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveShift(Shift item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetShift" />
		/// Database Table Shift
        /// </summary>
        virtual public Shift GetShift(byte shiftId)
        {
		    Shift result = null;
			this.Execute((manager) =>
			{
				result = manager.GetShift(shiftId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetShiftList" />
		/// Database Table Shift
        /// </summary>
        virtual public ShiftList GetShiftList(SqlWhereClause where)
        {
			ShiftList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetShiftList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveShift" />
		/// Database Table Shift
        /// </summary>
        virtual public Shift SaveShift(Shift item)
        {
			Shift result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveShift(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveShift" />
		/// Database Table Shift
        /// </summary>
        virtual public bool RemoveShift(Shift item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveShift(item);
			});
			return result;
        }
    }
}