﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ShipMethod' using it's primary key(s)
		/// Tabelle ShipMethod
        /// </summary>
        /// <returns>a new object of entity 'ShipMethod', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetShipMethod", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ShipMethod GetShipMethod(int shipMethodId);

        /// <summary>
        /// get list of entities 'ShipMethodList' using a Where clause
		/// Database Table ShipMethod
        /// </summary>
        /// <returns>Entity 'ShipMethodList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetShipMethodList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ShipMethodList GetShipMethodList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ShipMethod', accourding to entity content and state.
		/// Database Table ShipMethod
        /// </summary>
        /// <returns>Entity 'ShipMethod', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveShipMethod", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ShipMethod SaveShipMethod(ShipMethod item);

        /// <summary>
        /// Remove existing entity 'ShipMethod'
		/// Database Table ShipMethod
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveShipMethod", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveShipMethod(ShipMethod item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetShipMethod" />
		/// Database Table ShipMethod
        /// </summary>
        virtual public ShipMethod GetShipMethod(int shipMethodId)
        {
		    ShipMethod result = null;
			this.Execute((manager) =>
			{
				result = manager.GetShipMethod(shipMethodId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetShipMethodList" />
		/// Database Table ShipMethod
        /// </summary>
        virtual public ShipMethodList GetShipMethodList(SqlWhereClause where)
        {
			ShipMethodList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetShipMethodList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveShipMethod" />
		/// Database Table ShipMethod
        /// </summary>
        virtual public ShipMethod SaveShipMethod(ShipMethod item)
        {
			ShipMethod result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveShipMethod(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveShipMethod" />
		/// Database Table ShipMethod
        /// </summary>
        virtual public bool RemoveShipMethod(ShipMethod item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveShipMethod(item);
			});
			return result;
        }
    }
}