﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'ShoppingCartItem' using it's primary key(s)
		/// Tabelle ShoppingCartItem
        /// </summary>
        /// <returns>a new object of entity 'ShoppingCartItem', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetShoppingCartItem", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ShoppingCartItem GetShoppingCartItem(int shoppingCartItemId);

        /// <summary>
        /// get list of entities 'ShoppingCartItemList' using a Where clause
		/// Database Table ShoppingCartItem
        /// </summary>
        /// <returns>Entity 'ShoppingCartItemList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetShoppingCartItemList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ShoppingCartItemList GetShoppingCartItemList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'ShoppingCartItem', accourding to entity content and state.
		/// Database Table ShoppingCartItem
        /// </summary>
        /// <returns>Entity 'ShoppingCartItem', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveShoppingCartItem", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        ShoppingCartItem SaveShoppingCartItem(ShoppingCartItem item);

        /// <summary>
        /// Remove existing entity 'ShoppingCartItem'
		/// Database Table ShoppingCartItem
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveShoppingCartItem", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveShoppingCartItem(ShoppingCartItem item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetShoppingCartItem" />
		/// Database Table ShoppingCartItem
        /// </summary>
        virtual public ShoppingCartItem GetShoppingCartItem(int shoppingCartItemId)
        {
		    ShoppingCartItem result = null;
			this.Execute((manager) =>
			{
				result = manager.GetShoppingCartItem(shoppingCartItemId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetShoppingCartItemList" />
		/// Database Table ShoppingCartItem
        /// </summary>
        virtual public ShoppingCartItemList GetShoppingCartItemList(SqlWhereClause where)
        {
			ShoppingCartItemList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetShoppingCartItemList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveShoppingCartItem" />
		/// Database Table ShoppingCartItem
        /// </summary>
        virtual public ShoppingCartItem SaveShoppingCartItem(ShoppingCartItem item)
        {
			ShoppingCartItem result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveShoppingCartItem(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveShoppingCartItem" />
		/// Database Table ShoppingCartItem
        /// </summary>
        virtual public bool RemoveShoppingCartItem(ShoppingCartItem item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveShoppingCartItem(item);
			});
			return result;
        }
    }
}