﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SpecialOffer' using it's primary key(s)
		/// Tabelle SpecialOffer
        /// </summary>
        /// <returns>a new object of entity 'SpecialOffer', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSpecialOffer", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SpecialOffer GetSpecialOffer(int specialOfferId);

        /// <summary>
        /// get list of entities 'SpecialOfferList' using a Where clause
		/// Database Table SpecialOffer
        /// </summary>
        /// <returns>Entity 'SpecialOfferList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSpecialOfferList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SpecialOfferList GetSpecialOfferList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SpecialOffer', accourding to entity content and state.
		/// Database Table SpecialOffer
        /// </summary>
        /// <returns>Entity 'SpecialOffer', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSpecialOffer", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SpecialOffer SaveSpecialOffer(SpecialOffer item);

        /// <summary>
        /// Remove existing entity 'SpecialOffer'
		/// Database Table SpecialOffer
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSpecialOffer", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSpecialOffer(SpecialOffer item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSpecialOffer" />
		/// Database Table SpecialOffer
        /// </summary>
        virtual public SpecialOffer GetSpecialOffer(int specialOfferId)
        {
		    SpecialOffer result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSpecialOffer(specialOfferId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSpecialOfferList" />
		/// Database Table SpecialOffer
        /// </summary>
        virtual public SpecialOfferList GetSpecialOfferList(SqlWhereClause where)
        {
			SpecialOfferList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSpecialOfferList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSpecialOffer" />
		/// Database Table SpecialOffer
        /// </summary>
        virtual public SpecialOffer SaveSpecialOffer(SpecialOffer item)
        {
			SpecialOffer result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSpecialOffer(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSpecialOffer" />
		/// Database Table SpecialOffer
        /// </summary>
        virtual public bool RemoveSpecialOffer(SpecialOffer item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSpecialOffer(item);
			});
			return result;
        }
    }
}