﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'SpecialOfferProduct' using it's primary key(s)
		/// Tabelle SpecialOfferProduct
        /// </summary>
        /// <returns>a new object of entity 'SpecialOfferProduct', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSpecialOfferProduct", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SpecialOfferProduct GetSpecialOfferProduct(int specialOfferId, int productId);

        /// <summary>
        /// get list of entities 'SpecialOfferProductList' using a Where clause
		/// Database Table SpecialOfferProduct
        /// </summary>
        /// <returns>Entity 'SpecialOfferProductList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetSpecialOfferProductList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SpecialOfferProductList GetSpecialOfferProductList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'SpecialOfferProduct', accourding to entity content and state.
		/// Database Table SpecialOfferProduct
        /// </summary>
        /// <returns>Entity 'SpecialOfferProduct', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveSpecialOfferProduct", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        SpecialOfferProduct SaveSpecialOfferProduct(SpecialOfferProduct item);

        /// <summary>
        /// Remove existing entity 'SpecialOfferProduct'
		/// Database Table SpecialOfferProduct
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveSpecialOfferProduct", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveSpecialOfferProduct(SpecialOfferProduct item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetSpecialOfferProduct" />
		/// Database Table SpecialOfferProduct
        /// </summary>
        virtual public SpecialOfferProduct GetSpecialOfferProduct(int specialOfferId, int productId)
        {
		    SpecialOfferProduct result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSpecialOfferProduct(specialOfferId, productId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetSpecialOfferProductList" />
		/// Database Table SpecialOfferProduct
        /// </summary>
        virtual public SpecialOfferProductList GetSpecialOfferProductList(SqlWhereClause where)
        {
			SpecialOfferProductList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetSpecialOfferProductList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveSpecialOfferProduct" />
		/// Database Table SpecialOfferProduct
        /// </summary>
        virtual public SpecialOfferProduct SaveSpecialOfferProduct(SpecialOfferProduct item)
        {
			SpecialOfferProduct result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveSpecialOfferProduct(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveSpecialOfferProduct" />
		/// Database Table SpecialOfferProduct
        /// </summary>
        virtual public bool RemoveSpecialOfferProduct(SpecialOfferProduct item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveSpecialOfferProduct(item);
			});
			return result;
        }
    }
}