﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'StateProvince' using it's primary key(s)
		/// Tabelle StateProvince
        /// </summary>
        /// <returns>a new object of entity 'StateProvince', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetStateProvince", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        StateProvince GetStateProvince(int stateProvinceId);

        /// <summary>
        /// get list of entities 'StateProvinceList' using a Where clause
		/// Database Table StateProvince
        /// </summary>
        /// <returns>Entity 'StateProvinceList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetStateProvinceList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        StateProvinceList GetStateProvinceList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'StateProvince', accourding to entity content and state.
		/// Database Table StateProvince
        /// </summary>
        /// <returns>Entity 'StateProvince', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveStateProvince", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        StateProvince SaveStateProvince(StateProvince item);

        /// <summary>
        /// Remove existing entity 'StateProvince'
		/// Database Table StateProvince
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveStateProvince", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveStateProvince(StateProvince item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetStateProvince" />
		/// Database Table StateProvince
        /// </summary>
        virtual public StateProvince GetStateProvince(int stateProvinceId)
        {
		    StateProvince result = null;
			this.Execute((manager) =>
			{
				result = manager.GetStateProvince(stateProvinceId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetStateProvinceList" />
		/// Database Table StateProvince
        /// </summary>
        virtual public StateProvinceList GetStateProvinceList(SqlWhereClause where)
        {
			StateProvinceList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetStateProvinceList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveStateProvince" />
		/// Database Table StateProvince
        /// </summary>
        virtual public StateProvince SaveStateProvince(StateProvince item)
        {
			StateProvince result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveStateProvince(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveStateProvince" />
		/// Database Table StateProvince
        /// </summary>
        virtual public bool RemoveStateProvince(StateProvince item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveStateProvince(item);
			});
			return result;
        }
    }
}