﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'TransactionHistory' using it's primary key(s)
		/// Tabelle TransactionHistory
        /// </summary>
        /// <returns>a new object of entity 'TransactionHistory', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetTransactionHistory", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        TransactionHistory GetTransactionHistory(int transactionId);

        /// <summary>
        /// get list of entities 'TransactionHistoryList' using a Where clause
		/// Database Table TransactionHistory
        /// </summary>
        /// <returns>Entity 'TransactionHistoryList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetTransactionHistoryList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        TransactionHistoryList GetTransactionHistoryList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'TransactionHistory', accourding to entity content and state.
		/// Database Table TransactionHistory
        /// </summary>
        /// <returns>Entity 'TransactionHistory', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveTransactionHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        TransactionHistory SaveTransactionHistory(TransactionHistory item);

        /// <summary>
        /// Remove existing entity 'TransactionHistory'
		/// Database Table TransactionHistory
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveTransactionHistory", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveTransactionHistory(TransactionHistory item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetTransactionHistory" />
		/// Database Table TransactionHistory
        /// </summary>
        virtual public TransactionHistory GetTransactionHistory(int transactionId)
        {
		    TransactionHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.GetTransactionHistory(transactionId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetTransactionHistoryList" />
		/// Database Table TransactionHistory
        /// </summary>
        virtual public TransactionHistoryList GetTransactionHistoryList(SqlWhereClause where)
        {
			TransactionHistoryList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetTransactionHistoryList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveTransactionHistory" />
		/// Database Table TransactionHistory
        /// </summary>
        virtual public TransactionHistory SaveTransactionHistory(TransactionHistory item)
        {
			TransactionHistory result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveTransactionHistory(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveTransactionHistory" />
		/// Database Table TransactionHistory
        /// </summary>
        virtual public bool RemoveTransactionHistory(TransactionHistory item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveTransactionHistory(item);
			});
			return result;
        }
    }
}