﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'TransactionHistoryArchive' using it's primary key(s)
		/// Tabelle TransactionHistoryArchive
        /// </summary>
        /// <returns>a new object of entity 'TransactionHistoryArchive', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetTransactionHistoryArchive", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        TransactionHistoryArchive GetTransactionHistoryArchive(int transactionId);

        /// <summary>
        /// get list of entities 'TransactionHistoryArchiveList' using a Where clause
		/// Database Table TransactionHistoryArchive
        /// </summary>
        /// <returns>Entity 'TransactionHistoryArchiveList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetTransactionHistoryArchiveList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        TransactionHistoryArchiveList GetTransactionHistoryArchiveList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'TransactionHistoryArchive', accourding to entity content and state.
		/// Database Table TransactionHistoryArchive
        /// </summary>
        /// <returns>Entity 'TransactionHistoryArchive', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveTransactionHistoryArchive", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        TransactionHistoryArchive SaveTransactionHistoryArchive(TransactionHistoryArchive item);

        /// <summary>
        /// Remove existing entity 'TransactionHistoryArchive'
		/// Database Table TransactionHistoryArchive
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveTransactionHistoryArchive", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveTransactionHistoryArchive(TransactionHistoryArchive item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetTransactionHistoryArchive" />
		/// Database Table TransactionHistoryArchive
        /// </summary>
        virtual public TransactionHistoryArchive GetTransactionHistoryArchive(int transactionId)
        {
		    TransactionHistoryArchive result = null;
			this.Execute((manager) =>
			{
				result = manager.GetTransactionHistoryArchive(transactionId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetTransactionHistoryArchiveList" />
		/// Database Table TransactionHistoryArchive
        /// </summary>
        virtual public TransactionHistoryArchiveList GetTransactionHistoryArchiveList(SqlWhereClause where)
        {
			TransactionHistoryArchiveList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetTransactionHistoryArchiveList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveTransactionHistoryArchive" />
		/// Database Table TransactionHistoryArchive
        /// </summary>
        virtual public TransactionHistoryArchive SaveTransactionHistoryArchive(TransactionHistoryArchive item)
        {
			TransactionHistoryArchive result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveTransactionHistoryArchive(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveTransactionHistoryArchive" />
		/// Database Table TransactionHistoryArchive
        /// </summary>
        virtual public bool RemoveTransactionHistoryArchive(TransactionHistoryArchive item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveTransactionHistoryArchive(item);
			});
			return result;
        }
    }
}