﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'UnitMeasure' using it's primary key(s)
		/// Tabelle UnitMeasure
        /// </summary>
        /// <returns>a new object of entity 'UnitMeasure', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetUnitMeasure", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        UnitMeasure GetUnitMeasure(string unitMeasureCode);

        /// <summary>
        /// get list of entities 'UnitMeasureList' using a Where clause
		/// Database Table UnitMeasure
        /// </summary>
        /// <returns>Entity 'UnitMeasureList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetUnitMeasureList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        UnitMeasureList GetUnitMeasureList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'UnitMeasure', accourding to entity content and state.
		/// Database Table UnitMeasure
        /// </summary>
        /// <returns>Entity 'UnitMeasure', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveUnitMeasure", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        UnitMeasure SaveUnitMeasure(UnitMeasure item);

        /// <summary>
        /// Remove existing entity 'UnitMeasure'
		/// Database Table UnitMeasure
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveUnitMeasure", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveUnitMeasure(UnitMeasure item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetUnitMeasure" />
		/// Database Table UnitMeasure
        /// </summary>
        virtual public UnitMeasure GetUnitMeasure(string unitMeasureCode)
        {
		    UnitMeasure result = null;
			this.Execute((manager) =>
			{
				result = manager.GetUnitMeasure(unitMeasureCode);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetUnitMeasureList" />
		/// Database Table UnitMeasure
        /// </summary>
        virtual public UnitMeasureList GetUnitMeasureList(SqlWhereClause where)
        {
			UnitMeasureList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetUnitMeasureList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveUnitMeasure" />
		/// Database Table UnitMeasure
        /// </summary>
        virtual public UnitMeasure SaveUnitMeasure(UnitMeasure item)
        {
			UnitMeasure result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveUnitMeasure(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveUnitMeasure" />
		/// Database Table UnitMeasure
        /// </summary>
        virtual public bool RemoveUnitMeasure(UnitMeasure item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveUnitMeasure(item);
			});
			return result;
        }
    }
}