﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'Vendor' using it's primary key(s)
		/// Tabelle Vendor
        /// </summary>
        /// <returns>a new object of entity 'Vendor', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetVendor", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Vendor GetVendor(int businessEntityId);

        /// <summary>
        /// get list of entities 'VendorList' using a Where clause
		/// Database Table Vendor
        /// </summary>
        /// <returns>Entity 'VendorList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetVendorList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        VendorList GetVendorList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'Vendor', accourding to entity content and state.
		/// Database Table Vendor
        /// </summary>
        /// <returns>Entity 'Vendor', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveVendor", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        Vendor SaveVendor(Vendor item);

        /// <summary>
        /// Remove existing entity 'Vendor'
		/// Database Table Vendor
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveVendor", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveVendor(Vendor item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetVendor" />
		/// Database Table Vendor
        /// </summary>
        virtual public Vendor GetVendor(int businessEntityId)
        {
		    Vendor result = null;
			this.Execute((manager) =>
			{
				result = manager.GetVendor(businessEntityId);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetVendorList" />
		/// Database Table Vendor
        /// </summary>
        virtual public VendorList GetVendorList(SqlWhereClause where)
        {
			VendorList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetVendorList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveVendor" />
		/// Database Table Vendor
        /// </summary>
        virtual public Vendor SaveVendor(Vendor item)
        {
			Vendor result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveVendor(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveVendor" />
		/// Database Table Vendor
        /// </summary>
        virtual public bool RemoveVendor(Vendor item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveVendor(item);
			});
			return result;
        }
    }
}