﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.ServiceModel.Web;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial interface IAdventureWorksService
    {
		/// <summary>
        /// getting existing entity 'WorkOrderRouting' using it's primary key(s)
		/// Tabelle WorkOrderRouting
        /// </summary>
        /// <returns>a new object of entity 'WorkOrderRouting', <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetWorkOrderRouting", Method = "POST", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        WorkOrderRouting GetWorkOrderRouting(int workOrderId, int productId, short operationSequence);

        /// <summary>
        /// get list of entities 'WorkOrderRoutingList' using a Where clause
		/// Database Table WorkOrderRouting
        /// </summary>
        /// <returns>Entity 'WorkOrderRoutingList' with matched result</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/GetWorkOrderRoutingList", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        WorkOrderRoutingList GetWorkOrderRoutingList(SqlWhereClause where);

        /// <summary>
        /// Save or create an entity 'WorkOrderRouting', accourding to entity content and state.
		/// Database Table WorkOrderRouting
        /// </summary>
        /// <returns>Entity 'WorkOrderRouting', the saved/created entity, proof <see href="ResultInfo.IsValid"/></returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/SaveWorkOrderRouting", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        WorkOrderRouting SaveWorkOrderRouting(WorkOrderRouting item);

        /// <summary>
        /// Remove existing entity 'WorkOrderRouting'
		/// Database Table WorkOrderRouting
        /// </summary>
        /// <returns>true, when removed, false otherwise</returns>
        [OperationContract]
		[WebInvoke(UriTemplate = "/RemoveWorkOrderRouting", RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json, BodyStyle = WebMessageBodyStyle.Wrapped)]
		[ServiceKnownType("GetKnownTypes", typeof(KnownTypeProvider))]
        bool RemoveWorkOrderRouting(WorkOrderRouting item);
    }

    public partial class AdventureWorksService
    {
        /// <summary>
        /// <see href="IAdventureWorksService.GetWorkOrderRouting" />
		/// Database Table WorkOrderRouting
        /// </summary>
        virtual public WorkOrderRouting GetWorkOrderRouting(int workOrderId, int productId, short operationSequence)
        {
		    WorkOrderRouting result = null;
			this.Execute((manager) =>
			{
				result = manager.GetWorkOrderRouting(workOrderId, productId, operationSequence);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.GetWorkOrderRoutingList" />
		/// Database Table WorkOrderRouting
        /// </summary>
        virtual public WorkOrderRoutingList GetWorkOrderRoutingList(SqlWhereClause where)
        {
			WorkOrderRoutingList result = null;
			this.Execute((manager) =>
			{
				result = manager.GetWorkOrderRoutingList(where);
			});
			return result;
        }

        /// <summary>
        /// <see href="IAdventureWorksService.SaveWorkOrderRouting" />
		/// Database Table WorkOrderRouting
        /// </summary>
        virtual public WorkOrderRouting SaveWorkOrderRouting(WorkOrderRouting item)
        {
			WorkOrderRouting result = null;
			this.Execute((manager) =>
			{
				result = manager.SaveWorkOrderRouting(item);
			});
			return result;
        }
		
        /// <summary>
        /// <see href="IAdventureWorksService.RemoveWorkOrderRouting" />
		/// Database Table WorkOrderRouting
        /// </summary>
        virtual public bool RemoveWorkOrderRouting(WorkOrderRouting item)
        {
			bool result = false;
			this.Execute((manager) =>
			{
				result = manager.RemoveWorkOrderRouting(item);
			});
			return result;
        }
    }
}